SystemOrganization addCategory: #'GT-Metaceller-Model'!

Magnitude subclass: #GTMetacellerVersionName
	instanceVariableNames: 'original splitted'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Model'!

!GTMetacellerVersionName class methodsFor: 'instance creation' stamp: 'DiegoLont 3/30/2014 10:20'!
on: aString
	^self new
		original: aString;
		yourself! !

!GTMetacellerVersionName methodsFor: 'testing' stamp: 'DiegoLont 3/30/2014 10:38'!
< aVersionName
	self splitted withIndexDo: [ :each :index |
		each ~= (aVersionName at: index) ifTrue: [ 
			(aVersionName at: index) ifNil: [ ^false ].
			^each < (aVersionName at: index) ] ].
	" And the special case "
	^(self = aVersionName) not! !

!GTMetacellerVersionName methodsFor: 'testing' stamp: 'DiegoLont 3/30/2014 10:23'!
= aMagnitude
	self class == aMagnitude class ifFalse: [ ^false ].
	^self splitted = aMagnitude splitted! !

!GTMetacellerVersionName methodsFor: 'accessing' stamp: 'DiegoLont 3/30/2014 10:39'!
at: anIndex
	(self splitted size < anIndex) ifTrue: [ ^nil ].
	^self splitted at: anIndex! !

!GTMetacellerVersionName methodsFor: 'hash' stamp: 'DiegoLont 3/30/2014 10:22'!
hash
	^self splitted hash! !

!GTMetacellerVersionName methodsFor: 'accessing' stamp: 'DiegoLont 3/30/2014 10:20'!
original
	^ original! !

!GTMetacellerVersionName methodsFor: 'accessing' stamp: 'DiegoLont 3/30/2014 10:20'!
original: anObject
	original := anObject! !

!GTMetacellerVersionName methodsFor: 'accessing' stamp: 'DiegoLont 3/30/2014 10:30'!
size
	^self splitted size! !

!GTMetacellerVersionName methodsFor: 'accessing' stamp: 'DiegoLont 3/30/2014 10:25'!
splitted
	^splitted ifNil: [ splitted := (original subStrings: '.') collect: [ :each |
		Number readFrom: each ifFail: [ each ] ] ]! !

!MetacelloAddMemberSpec methodsFor: '*gt-metaceller-model' stamp: 'DiegoLont 3/24/2014 14:40'!
repositoryDescription
	^self spec repositoryDescription! !

!MetacelloPackageSpec methodsFor: '*GT-Metaceller-Model' stamp: 'TudorGirba 4/1/2013 09:16'!
hasNewerVersionsFrom: version
	| g |
	g := Gofer new.
	version spec repositories list do: [:each | g url: each name ].
	g package: self name.
	^ g resolved first name ~= self currentVersionInfo name! !

!MetacelloPackageSpec methodsFor: '*GT-Metaceller-Model' stamp: 'TudorGirba 4/1/2013 09:07'!
needsSaving
	| copy |
	copy := self workingCopy.
	copy isNil ifTrue: [^ false ].
	^ copy needsSaving! !

!MetacelloRepositoriesSpec methodsFor: '*gt-metaceller-model' stamp: 'DiegoLont 3/24/2014 14:47'!
repositoryDescriptions
	^(self list collect: [ :each | each repositoryDescription ])! !

MetacelloPlatform subclass: #GTMetacelloPlatform
	instanceVariableNames: 'originalPlatform platformDescription'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Model'!

!GTMetacelloPlatform class methodsFor: 'private' stamp: 'DiegoLont 9/16/2013 11:51'!
defaultPlatformDescription
	(self current isKindOf: self) ifFalse: [ self initialize ].
	^self current platformDescription! !

!GTMetacelloPlatform class methodsFor: 'private' stamp: 'DiegoLont 9/16/2013 11:51'!
defaultPlatformDescription: aGTPlatformDescription 
	(self current isKindOf: self) ifFalse: [ self initialize ].
	^self current platformDescription: aGTPlatformDescription ! !

!GTMetacelloPlatform class methodsFor: 'initialization' stamp: 'DiegoLont 9/14/2013 14:50'!
initialize
	"
	GTMetacelloPlatform initialize
	"
	Current := self on: Current! !

!GTMetacelloPlatform class methodsFor: 'instance creation' stamp: 'DiegoLont 9/14/2013 14:52'!
new
	" this platform should always be created with a default platform "
	^self shouldNotImplement! !

!GTMetacelloPlatform class methodsFor: 'instance creation' stamp: 'DiegoLont 9/14/2013 14:51'!
on: aPlatform
	^self basicNew
		initialize: aPlatform;
		yourself! !

!GTMetacelloPlatform methodsFor: 'utilities' stamp: 'DiegoLont 9/16/2013 11:01'!
authorName
	^self originalPlatform authorName! !

!GTMetacelloPlatform methodsFor: 'utilities' stamp: 'DiegoLont 9/16/2013 11:01'!
authorName: aValue
	^self originalPlatform authorName: aValue! !

!GTMetacelloPlatform methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 11:01'!
bypassGoferLoadUpdateCategories
	^self originalPlatform bypassGoferLoadUpdateCategories! !

!GTMetacelloPlatform methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 11:01'!
bypassGoferLoadUpdateCategories: anObject
	^self originalPlatform bypassGoferLoadUpdateCategories: anObject! !

!GTMetacelloPlatform methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 11:01'!
bypassProgressBars
	^self originalPlatform bypassProgressBars! !

!GTMetacelloPlatform methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 11:02'!
bypassProgressBars: anObject
	^self originalPlatform bypassProgressBars: anObject! !

!GTMetacelloPlatform methodsFor: 'caching' stamp: 'DiegoLont 9/16/2013 11:02'!
clearCurrentVersionCache
	^self originalPlatform clearCurrentVersionCache! !

!GTMetacelloPlatform methodsFor: 'notification' stamp: 'DiegoLont 9/16/2013 11:02'!
collection: aCollection do: aBlock displaying: aString
	^self originalPlatform collection: aCollection do: aBlock displaying: aString! !

!GTMetacelloPlatform methodsFor: 'user interaction' stamp: 'DiegoLont 9/16/2013 11:02'!
confirm: aString
	^self originalPlatform confirm: aString! !

!GTMetacelloPlatform methodsFor: 'reflection' stamp: 'DiegoLont 9/16/2013 11:03'!
copyClass: oldClass as: newName inCategory: newCategoryName
	^self originalPlatform copyClass: oldClass as: newName inCategory: newCategoryName! !

!GTMetacelloPlatform methodsFor: 'repository creation' stamp: 'DiegoLont 9/16/2013 11:03'!
createRepository: aRepositorySpec
	^self originalPlatform createRepository: aRepositorySpec! !

!GTMetacelloPlatform methodsFor: 'file system' stamp: 'JohanBrichau 2/22/2014 14:28'!
defaultDirectory
	^self originalPlatform defaultDirectory! !

!GTMetacelloPlatform methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 11:50'!
defaultPlatformAttributes
	self platformDescription ifNil: [ ^self originalPlatform defaultPlatformAttributes ].
	^self platformDescription attributes! !

!GTMetacelloPlatform methodsFor: 'tests' stamp: 'DiegoLont 9/16/2013 11:04'!
defaultTimeout
	^self originalPlatform defaultTimeout! !

!GTMetacelloPlatform methodsFor: 'file system' stamp: 'JohanBrichau 2/22/2014 14:28'!
directoryFromPath: adirectoryPath relativeTo: anotherDirectoryPath
	^ self originalPlatform directoryFromPath: adirectoryPath relativeTo: anotherDirectoryPath! !

!GTMetacelloPlatform methodsFor: 'notification' stamp: 'DiegoLont 9/16/2013 11:03'!
do: aBlock displaying: aString
	^self originalPlatform do: aBlock displaying: aString! !

!GTMetacelloPlatform methodsFor: 'github support' stamp: 'JohanBrichau 2/22/2014 14:31'!
downloadFile: url to: outputFileName
	^ self originalPlatform downloadFile: url to: outputFileName! !

!GTMetacelloPlatform methodsFor: 'file system' stamp: 'JohanBrichau 2/22/2014 14:28'!
ensureDirectoryExists: aDirectoryHandle
	^self originalPlatform ensureDirectoryExists: aDirectoryHandle! !

!GTMetacelloPlatform methodsFor: 'github support' stamp: 'JohanBrichau 2/22/2014 14:32'!
extractRepositoryFrom: zipFile to: directory
	^self originalPlatform extractRepositoryFrom: zipFile to: directory! !

!GTMetacelloPlatform methodsFor: 'repository creation' stamp: 'DiegoLont 9/16/2013 11:04'!
extractTypeFromDescription: description

	^self originalPlatform extractTypeFromDescription: description
! !

!GTMetacelloPlatform methodsFor: 'github support' stamp: 'JohanBrichau 2/22/2014 14:27'!
fileDirectoryClass
	^self originalPlatform fileDirectoryClass! !

!GTMetacelloPlatform methodsFor: 'file system' stamp: 'JohanBrichau 2/22/2014 14:29'!
fileHandleOn: aPath
	^self originalPlatform fileHandleOn: aPath! !

!GTMetacelloPlatform methodsFor: 'reflection' stamp: 'DiegoLont 9/16/2013 11:04'!
globalNamed: globalName

	^self originalPlatform globalNamed: globalName! !

!GTMetacelloPlatform methodsFor: 'reflection' stamp: 'DiegoLont 9/16/2013 11:04'!
globalNamed: globalName ifAbsent: absentBlock

	^self originalPlatform globalNamed: globalName ifAbsent: absentBlock! !

!GTMetacelloPlatform methodsFor: 'initialization' stamp: 'DiegoLont 9/14/2013 15:14'!
initialize: aPlatform
	self initialize.
	originalPlatform := aPlatform! !

!GTMetacelloPlatform methodsFor: 'accessing' stamp: 'DiegoLont 9/14/2013 15:18'!
originalPlatform
	^originalPlatform! !

!GTMetacelloPlatform methodsFor: 'file system' stamp: 'JohanBrichau 2/22/2014 14:30'!
parentDirectoryOf: aFileHandler
	^self originalPlatform parentDirectoryOf: aFileHandler! !

!GTMetacelloPlatform methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 11:50'!
platformDescription
	^platformDescription! !

!GTMetacelloPlatform methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 11:51'!
platformDescription: aGTPlatformDescription 
	platformDescription := aGTPlatformDescription! !

!GTMetacelloPlatform methodsFor: 'caching' stamp: 'DiegoLont 9/16/2013 11:04'!
primeStackCacheFor: cacheName doing: noArgBlock defaultDictionary: aDictionary
	^self originalPlatform primeStackCacheFor: cacheName doing: noArgBlock defaultDictionary: aDictionary! !

!GTMetacelloPlatform methodsFor: 'caching' stamp: 'DiegoLont 9/16/2013 11:04'!
primeStackCacheWith: aDictionary doing: noArgBlock
	^self originalPlatform primeStackCacheWith: aDictionary doing: noArgBlock! !

!GTMetacelloPlatform methodsFor: 'file system' stamp: 'JohanBrichau 2/22/2014 14:30'!
readStreamOn: aFileHandle do: aBlock
	^self originalPlatform readStreamOn: aFileHandle do: aBlock! !

!GTMetacelloPlatform methodsFor: 'file system' stamp: 'JohanBrichau 2/22/2014 14:30'!
recursiveDelete: aDirectory
	^self originalPlatform recursiveDelete: aDirectory! !

!GTMetacelloPlatform methodsFor: 'caching' stamp: 'DiegoLont 9/16/2013 11:05'!
stackCacheFor: cacheName at: key doing: aBlock
	^self originalPlatform stackCacheFor: cacheName at: key doing: aBlock! !

!GTMetacelloPlatform methodsFor: 'caching' stamp: 'DiegoLont 9/16/2013 11:05'!
stackCacheFor: cacheName cacheClass: cacheClass at: key doing: aBlock

	^self originalPlatform stackCacheFor: cacheName cacheClass: cacheClass at: key doing: aBlock
! !

!GTMetacelloPlatform methodsFor: 'utilities' stamp: 'DiegoLont 9/16/2013 11:05'!
timestamp

	^self originalPlatform timestamp! !

!GTMetacelloPlatform methodsFor: 'transactions' stamp: 'DiegoLont 9/16/2013 11:05'!
transact: aBlock

	^self originalPlatform transact: aBlock! !

!GTMetacelloPlatform methodsFor: 'caching' stamp: 'DiegoLont 9/16/2013 11:05'!
useStackCacheDuring: aBlock defaultDictionary: defaultDictionary
	^self originalPlatform useStackCacheDuring: aBlock defaultDictionary: defaultDictionary! !

!MetacelloVersionConstructor methodsFor: '*gt-metaceller-model' stamp: 'DiegoLont 1/20/2014 14:18'!
versionImportPragmasVerifiedDefinedIn: versionMap 
	| pragmaDict |
	pragmaDict := self extractVersionImportPragmas.
	pragmaDict
		keysAndValuesDo: [:versionString :pragmaColl | pragmaColl
				do: [:pragma | (pragma argumentAt: 2)
						do: [:importedVersion | versionMap
								at: importedVersion
								ifAbsent: [pragmaDict
										at: importedVersion
										ifAbsent: [^ self error: 'The imported version:' , importedVersion printString , ' referenced from the method: ' , pragma selector printString , ' in configuration ' , configuration class printString , ' has not been defined.']]]]].
	^ pragmaDict! !

!MetacelloRepositorySpec methodsFor: '*gt-metaceller-model' stamp: 'DiegoLont 4/8/2014 15:23'!
repositoryDescription
	^self description! !

!String methodsFor: '*gt-metaceller-model' stamp: 'DiegoLont 3/30/2014 10:29'!
asMetacellerVersion
	^GTMetacellerVersionName on: self! !

!SequenceableCollection methodsFor: '*gt-metaceller-model' stamp: 'DiegoLont 3/25/2014 10:29'!
repositoryDescriptions
	^self collect: [ :each | each repositoryDescription ]! !

Announcement subclass: #GTConfigChanged
	instanceVariableNames: 'config'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Model'!

!GTConfigChanged class methodsFor: 'instance creation' stamp: 'DiegoLont 3/14/2014 13:50'!
on: aConfig
	^self new
		config: aConfig;
		yourself! !

!GTConfigChanged methodsFor: 'accessing' stamp: 'DiegoLont 3/14/2014 13:51'!
config
	^config! !

!GTConfigChanged methodsFor: 'accessing' stamp: 'DiegoLont 3/14/2014 13:51'!
config: aConfiguration
	config := aConfiguration! !

GTConfigChanged subclass: #GTConfigLoaded
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Model'!

Announcement subclass: #GTVersionChanged
	instanceVariableNames: 'version'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Model'!

!GTVersionChanged class methodsFor: 'instance creation' stamp: 'DiegoLont 3/25/2014 12:19'!
on: aVersion
	^self new
		version: aVersion;
		yourself! !

!GTVersionChanged methodsFor: 'accessing' stamp: 'DiegoLont 3/25/2014 12:19'!
version
	^ version! !

!GTVersionChanged methodsFor: 'accessing' stamp: 'DiegoLont 3/25/2014 12:19'!
version: anObject
	version := anObject! !

Object subclass: #GTMetacellerConfiguration
	instanceVariableNames: 'configuration mainProject platformSymbols status'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Model'!

!GTMetacellerConfiguration class methodsFor: 'instance creation' stamp: 'DiegoLont 9/13/2013 09:27'!
on: aConfiguration
	^self basicNew
		initialize: aConfiguration;
		yourself! !

!GTMetacellerConfiguration methodsFor: 'accessing' stamp: 'DiegoLont 3/18/2014 09:43'!
basicVersions
	| retVal |
	retVal := OrderedCollection new.
	self stableVersion ifNotNilDo: [ :ver | retVal add: ver ].
	self developmentVersion ifNotNilDo: [ :ver | 
		(retVal includes: ver) ifFalse: [ retVal add: ver ] ].
	self bleedingEdgeVersion ifNotNilDo: [ :ver | 
		(retVal includes: ver) ifFalse: [ retVal add: ver ] ].
	^retVal! !

!GTMetacellerConfiguration methodsFor: 'accessing' stamp: 'DiegoLont 3/17/2014 14:25'!
bleedingEdgeVersion
	^self mainProject bleedingEdgeVersion! !

!GTMetacellerConfiguration methodsFor: 'accessing project' stamp: 'DiegoLont 4/9/2014 10:10'!
childPlatformsFor: aPlatform
	^self mainProject childPlatformsFor: aPlatform! !

!GTMetacellerConfiguration methodsFor: 'accessing' stamp: 'DiegoLont 9/13/2013 10:13'!
children
	^self mainProject childConfigurations collect: [ :each | GTMetacellerConfiguration on: each ]! !

!GTMetacellerConfiguration methodsFor: 'accessing-magritte' stamp: 'DiegoLont 3/19/2014 10:40'!
configName
	^self shortName! !

!GTMetacellerConfiguration methodsFor: 'accessing' stamp: 'DiegoLont 9/13/2013 09:28'!
configuration
	^configuration! !

!GTMetacellerConfiguration methodsFor: 'accessing project' stamp: 'DiegoLont 4/9/2014 11:17'!
defaultVersion
	^self mainProject defaultVersion! !

!GTMetacellerConfiguration methodsFor: 'magritte-description' stamp: 'DiegoLont 3/14/2014 15:33'!
descriptionDevelopmentVersion
	<magritteDescription>
	^MASingleOptionDescription new
		label: 'Development';
		accessor: #developmentVersion;
		priority: 300;
		options: self possibleSymbolicVersions;
		yourself! !

!GTMetacellerConfiguration methodsFor: 'magritte-description' stamp: 'DiegoLont 3/14/2014 15:21'!
descriptionName
	<magritteDescription>
	^MAStringDescription new
		beReadonly;
		label: 'Name';
		accessor: #configName;
		priority: 100;
		yourself! !

!GTMetacellerConfiguration methodsFor: 'magritte-description' stamp: 'DiegoLont 3/14/2014 15:33'!
descriptionStableVersion
	<magritteDescription>
	^MASingleOptionDescription new
		label: 'Stable';
		accessor: #stableVersion;
		priority: 200;
		options: self possibleSymbolicVersions;
		yourself! !

!GTMetacellerConfiguration methodsFor: 'magritte-description' stamp: 'DiegoLont 3/14/2014 15:44'!
descriptionStatus
	<magritteDescription>
	^MAMemoDescription new
		beReadonly;
		label: 'Status';
		accessor: #status;
		priority: 150;
		yourself! !

!GTMetacellerConfiguration methodsFor: 'accessing-magritte' stamp: 'DiegoLont 3/14/2014 15:41'!
developmentVersion
	^self mainProject developmentVersion! !

!GTMetacellerConfiguration methodsFor: 'accessing-magritte' stamp: 'DiegoLont 3/28/2014 09:48'!
developmentVersion: aVersion
	" todo "
	self halt! !

!GTMetacellerConfiguration methodsFor: 'accessing' stamp: 'DiegoLont 9/13/2013 10:07'!
displayString
	^self shortName! !

!GTMetacellerConfiguration methodsFor: 'accessing' stamp: 'DiegoLont 3/17/2014 14:29'!
groups
	^self mainProject groups! !

!GTMetacellerConfiguration methodsFor: 'accessing' stamp: 'DiegoLont 3/18/2014 09:58'!
groupsAndLoosePackages
	^self mainProject groupsAndLoosePackages! !

!GTMetacellerConfiguration methodsFor: 'initialization' stamp: 'DiegoLont 9/13/2013 09:27'!
initialize: aConfiguration
	self initialize.
	configuration := aConfiguration! !

!GTMetacellerConfiguration methodsFor: 'actions' stamp: 'DiegoLont 3/18/2014 10:55'!
install: aGroupList 
	self mainProject install: aGroupList! !

!GTMetacellerConfiguration methodsFor: 'accessing' stamp: 'DiegoLont 3/17/2014 14:23'!
latestVersion
	^self mainProject latestVersion! !

!GTMetacellerConfiguration methodsFor: 'accessing' stamp: 'DiegoLont 9/13/2013 10:18'!
mainMethods
	^self mainProject allMethods ! !

!GTMetacellerConfiguration methodsFor: 'accessing project' stamp: 'DiegoLont 9/16/2013 13:26'!
mainProject
	^mainProject ifNil: [ mainProject := GTMetacellerMainProject on: self configuration ]! !

!GTMetacellerConfiguration methodsFor: 'accessing' stamp: 'DiegoLont 9/13/2013 10:17'!
mainVersions
	^self mainProject versions! !

!GTMetacellerConfiguration methodsFor: 'accessing-magritte' stamp: 'DiegoLont 3/14/2014 15:48'!
possibleSymbolicVersions
	^self mainProject versions sort: [ :a :b | a asString < b asString ]! !

!GTMetacellerConfiguration methodsFor: 'accessing' stamp: 'DiegoLont 3/28/2014 09:55'!
projectFor: aSymbol
	^self mainProject projectFor: aSymbol! !

!GTMetacellerConfiguration methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 13:05'!
projects
	^self mainProject projects! !

!GTMetacellerConfiguration methodsFor: 'accessing' stamp: 'DiegoLont 4/1/2014 10:35'!
releases
	^self mainProject releases! !

!GTMetacellerConfiguration methodsFor: 'private' stamp: 'DiegoLont 3/28/2014 09:49'!
reset
	mainProject := nil.
	platformSymbols := nil.
	status := nil! !

!GTMetacellerConfiguration methodsFor: 'display' stamp: 'DiegoLont 9/13/2013 10:07'!
shortName
	^ ((self configuration name beginsWith: 'ConfigurationOf') 
		ifTrue: [self configuration name copyFrom: 'ConfigurationOf' size + 1 to: self configuration name size ] 
		ifFalse: [self configuration name]) asString! !

!GTMetacellerConfiguration methodsFor: 'accessing-magritte' stamp: 'DiegoLont 3/14/2014 15:42'!
stableVersion
	^self mainProject stableVersion! !

!GTMetacellerConfiguration methodsFor: 'accessing-magritte' stamp: 'DiegoLont 3/14/2014 15:43'!
stableVersion: aVersion
	" todo "! !

!GTMetacellerConfiguration methodsFor: 'accessing-magritte' stamp: 'DiegoLont 3/14/2014 15:44'!
status
	^status ifNil: [ 'Not tested' ]! !

!GTMetacellerConfiguration methodsFor: 'actions' stamp: 'DiegoLont 4/2/2014 13:41'!
test: aCollection 
	self mainProject test: aCollection! !

!GTMetacellerConfiguration methodsFor: 'actions' stamp: 'DiegoLont 3/14/2014 16:25'!
testConfiguration
	status := #tested! !

!GTMetacellerConfiguration methodsFor: 'display' stamp: 'DiegoLont 3/25/2014 14:07'!
title
	^self shortName! !

!GTMetacellerConfiguration methodsFor: 'actions' stamp: 'DiegoLont 3/19/2014 12:01'!
validate
	self mainProject validate! !

!GTMetacellerConfiguration methodsFor: 'actions' stamp: 'DiegoLont 4/2/2014 13:40'!
validate: aCollection 
	self mainProject validate: aCollection! !

!GTMetacellerConfiguration methodsFor: 'accessing project' stamp: 'DiegoLont 4/2/2014 16:13'!
version: aString 
	^self mainProject version: aString! !

!GTMetacellerConfiguration methodsFor: 'roassal' stamp: 'DiegoLont 9/13/2013 11:36'!
viewVersionMapOn: view
	self mainProject viewVersionMapOn: view! !

Object subclass: #GTMetacellerLoadList
	instanceVariableNames: 'items errors warnings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Model'!

!GTMetacellerLoadList methodsFor: 'adding' stamp: 'DiegoLont 5/12/2014 14:31'!
add: anItem 
	^self add: anItem children: anItem children! !

!GTMetacellerLoadList methodsFor: 'adding' stamp: 'DiegoLont 5/12/2014 14:32'!
add: anItem children: aList
	(self findItem: anItem)
		ifNil: [ 
			self items add: anItem.
			aList do: [ :each | self add: each ] ]
		ifNotNilDo: [ :existing |
			| merged |
			merged := existing mergeWith: anItem errors: self errors warnings: self warnings.
			merged ifNil: [ self items add: anItem ]
				ifNotNil: [
					self items remove: existing.
					self items add: merged.
					aList do: [ :each | self add: each children: each children ] ] ]! !

!GTMetacellerLoadList methodsFor: 'accessing' stamp: 'DiegoLont 5/12/2014 14:15'!
errors
	^errors ifNil: [ errors := OrderedCollection new ]! !

!GTMetacellerLoadList methodsFor: 'accessing' stamp: 'DiegoLont 5/12/2014 13:50'!
findItem: anItem 
	^self items detect: [ :each |
		each isCompatibleWith: anItem ] ifNone: [ nil ]! !

!GTMetacellerLoadList methodsFor: 'accessing' stamp: 'DiegoLont 5/12/2014 13:50'!
items
	^items ifNil: [ items := OrderedCollection new ]! !

!GTMetacellerLoadList methodsFor: 'accessing' stamp: 'DiegoLont 5/12/2014 14:15'!
warnings
	^warnings ifNil: [ warnings := OrderedCollection new ]! !

Object subclass: #GTMetacellerModel
	instanceVariableNames: 'configs sortedCache announcer test'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Model'!

GTMetacellerModel class
	instanceVariableNames: 'default'!

GTMetacellerModel class
	instanceVariableNames: 'default'!

!GTMetacellerModel class methodsFor: 'events' stamp: 'DiegoLont 3/19/2014 12:00'!
announce: anAnnouncement
	self default announce: anAnnouncement! !

!GTMetacellerModel class methodsFor: 'singleton' stamp: 'DiegoLont 3/14/2014 11:42'!
default
	^default ifNil: [ default := self new ]! !

!GTMetacellerModel class methodsFor: 'singleton' stamp: 'DiegoLont 3/14/2014 13:41'!
reset
	default := nil! !

!GTMetacellerModel methodsFor: 'accessing' stamp: 'DiegoLont 3/14/2014 11:49'!
announce: anAnnouncement
	self announcer announce: anAnnouncement! !

!GTMetacellerModel methodsFor: 'accessing' stamp: 'DiegoLont 3/14/2014 11:49'!
announcer
	^announcer ifNil: [ announcer := Announcer new ]! !

!GTMetacellerModel methodsFor: 'initialization' stamp: 'DiegoLont 3/14/2014 15:10'!
buildConfigs
	| retVal |
	retVal := Dictionary new.
	Object subclasses do: [:each | (self isMetacelloConfig: each)
		ifTrue: [ retVal at: each put: (GTMetacellerConfiguration on: each) ] ].
	^retVal! !

!GTMetacellerModel methodsFor: 'initialization' stamp: 'DiegoLont 3/14/2014 12:08'!
buildSortedCache
	^ (self configs values sort: [:a :b | a displayString < b displayString])! !

!GTMetacellerModel methodsFor: 'events' stamp: 'DiegoLont 3/14/2014 15:31'!
classRemoved: anAnnouncement
	((configs includesKey: anAnnouncement classRemoved) 
		or: [ self isMetacelloConfig: anAnnouncement classRemoved ]) ifTrue: [ 
		| config |
		config := configs at: anAnnouncement classRemoved ifAbsent: [ nil ].
		configs removeKey: anAnnouncement classRemoved ifAbsent: [ ].
		sortedCache := nil.
		self announce: (GTConfigLoaded on: config) ]! !

!GTMetacellerModel methodsFor: 'events' stamp: 'DiegoLont 3/14/2014 14:27'!
classRenamed: anAnnouncement
	(self isMetacelloConfig: anAnnouncement classRenamed) ifTrue: [ 
		Transcript log: '...'.
		(configs at: anAnnouncement classRenamed ifAbsent: [ nil ])
			ifNotNilDo: [ :config | config reset. sortedCache := nil ].
		self announce: (GTConfigLoaded on: (configs at: anAnnouncement classRenamed)) ]! !

!GTMetacellerModel methodsFor: 'accessing' stamp: 'DiegoLont 3/14/2014 12:07'!
configs
	^configs ifNil: [ configs := self buildConfigs ]! !

!GTMetacellerModel methodsFor: 'accessing' stamp: 'DiegoLont 3/14/2014 12:10'!
configurations
	^self sortedCache! !

!GTMetacellerModel methodsFor: 'initialization' stamp: 'DiegoLont 3/14/2014 11:56'!
initialize
	super initialize.
	self register! !

!GTMetacellerModel methodsFor: 'testing' stamp: 'DiegoLont 3/14/2014 14:07'!
isMetacelloConfig: anObject
	(anObject respondsTo: #isMetacelloConfig) ifTrue: [  
		(anObject className beginsWith: 'Metacello') ifFalse: [ ^anObject isMetacelloConfig ] ].
	^false! !

!GTMetacellerModel methodsFor: 'events' stamp: 'DiegoLont 3/14/2014 15:10'!
methodChanged: anAnnouncement
	(self isMetacelloConfig: anAnnouncement methodClass) ifTrue: [
		(configs includesKey: anAnnouncement methodClass)
			ifTrue: [ (configs at: anAnnouncement methodClass) reset.
				self announce: (GTConfigChanged on: (configs at: anAnnouncement methodClass)) ]
			ifFalse: [
				configs at: anAnnouncement methodClass
					put: (GTMetacellerConfiguration on: anAnnouncement methodClass).
				sortedCache := nil.
				self announce: (GTConfigLoaded on: (configs at: anAnnouncement methodClass)) ] ]
		ifFalse: [
			(configs includesKey: anAnnouncement methodClass) ifTrue: [ 
				| config |
				config := configs at: anAnnouncement methodClass.
				configs removeKey: anAnnouncement methodClass.
				sortedCache := nil.
				self announce: (GTConfigLoaded on: config) ] ]! !

!GTMetacellerModel methodsFor: 'events' stamp: 'DiegoLont 3/14/2014 14:25'!
register
	SystemAnnouncer uniqueInstance weak
		on: ClassRemoved send: #classRemoved: to: self;
		on: ClassRenamed send: #classRenamed: to: self;
		on: MethodAdded send: #methodChanged: to: self;
		on: MethodModified send: #methodChanged: to: self;
		on: MethodRemoved send: #methodChanged: to: self;
		yourself! !

!GTMetacellerModel methodsFor: 'test' stamp: 'DiegoLont 3/14/2014 14:12'!
resetTest
	test := nil! !

!GTMetacellerModel methodsFor: 'accessing' stamp: 'DiegoLont 3/14/2014 12:10'!
sortedCache
	^sortedCache ifNil: [ sortedCache := self buildSortedCache ]! !

!GTMetacellerModel methodsFor: 'accessing' stamp: 'DiegoLont 3/14/2014 14:07'!
test
	^test ifNil: [ test := OrderedCollection new ]! !

Object subclass: #GTMetacellerProject
	instanceVariableNames: 'configuration project versions releases stableVersion bleedingEdge development currentVersion latest'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Model'!

GTMetacellerProject subclass: #GTMetacellerAtributedProject
	instanceVariableNames: 'platformDescription mainProject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Model'!

!GTMetacellerAtributedProject class methodsFor: 'instance creation' stamp: 'DiegoLont 3/24/2014 13:06'!
on: aConfigurationClass main: aMainProject platform: aPlatformDescription
	^self basicNew
		initialize: aConfigurationClass main: aMainProject platform: aPlatformDescription;
		yourself! !

!GTMetacellerAtributedProject methodsFor: 'accessing' stamp: 'DiegoLont 4/9/2014 10:19'!
childPlatforms
	^self children collect: [ :each | each platformSymbol ]! !

!GTMetacellerAtributedProject methodsFor: 'accessing' stamp: 'DiegoLont 4/9/2014 10:19'!
children
	self ensureProjectsCreated.
	^self defaultVersion children collect: [ :each | each project ]! !

!GTMetacellerAtributedProject methodsFor: 'code generation' stamp: 'DiegoLont 3/26/2014 11:52'!
createTempClass
	^AnonymousClassInstaller make: [ :builder |
		builder
			superclass: self configuration;
			buildNewClass ]! !

!GTMetacellerAtributedProject methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 13:23'!
displayString
	^self platformDescription symbol asString! !

!GTMetacellerAtributedProject methodsFor: 'actions' stamp: 'DiegoLont 4/8/2014 14:40'!
ensureProjectsCreated
	self mainProject ensureProjectsCreated! !

!GTMetacellerAtributedProject methodsFor: 'testing' stamp: 'DiegoLont 9/16/2013 11:54'!
hasAttributes
	^true! !

!GTMetacellerAtributedProject methodsFor: 'testing' stamp: 'DiegoLont 9/17/2013 09:25'!
hasPlatform: aPlatform
	^self platformDescription hasSymbol: aPlatform! !

!GTMetacellerAtributedProject methodsFor: 'initialization' stamp: 'DiegoLont 9/17/2013 09:30'!
initialize: aConfigurationClass main: aMainProject platform: aPlatformDescription
	self initialize: aConfigurationClass.
	mainProject := aMainProject.
	platformDescription := aPlatformDescription! !

!GTMetacellerAtributedProject methodsFor: 'accessing' stamp: 'DiegoLont 9/17/2013 13:19'!
itemsFor: aPlatform in: aVersion 
	^(self version: aVersion) items select: [ :each | (each hasPlatform: aPlatform) and: [ each isGroup not ] ]! !

!GTMetacellerAtributedProject methodsFor: 'accessing' stamp: 'DiegoLont 9/17/2013 09:30'!
mainProject
	^mainProject! !

!GTMetacellerAtributedProject methodsFor: 'accessing' stamp: 'DiegoLont 3/24/2014 12:43'!
parentProject
	^self mainProject parentProjectFor: self platformDescription! !

!GTMetacellerAtributedProject methodsFor: 'accessing' stamp: 'DiegoLont 3/24/2014 14:24'!
parentVersionFor: aMethod 
	^self parentProject
		ifNil: [ self mainProject parentVersionFor: aMethod ]
		ifNotNilDo: [ :parentProject | parentProject versionFor: aMethod ]! !

!GTMetacellerAtributedProject methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 11:44'!
platformDescription
	^ platformDescription! !

!GTMetacellerAtributedProject methodsFor: 'accessing' stamp: 'DiegoLont 3/24/2014 14:26'!
platformSymbol
	^self platformDescription symbol! !

!GTMetacellerAtributedProject methodsFor: 'accessing' stamp: 'DiegoLont 9/17/2013 09:29'!
platformsFor: anItem version: aVersion 
	^self mainProject platformsFor: anItem version: aVersion! !

!GTMetacellerAtributedProject methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 11:45'!
project
	^project ifNil: [ 
		GTMetacelloPlatform defaultPlatformDescription: self platformDescription.
		[ project := configuration project ] ensure: [ GTMetacelloPlatform defaultPlatformDescription: nil ] ]! !

!GTMetacellerAtributedProject methodsFor: 'actions' stamp: 'DiegoLont 3/28/2014 12:13'!
updateVersionToCurrent: aString 
	(self version: aString) updateToCurrent! !

GTMetacellerProject subclass: #GTMetacellerMainProject
	instanceVariableNames: 'platformSymbols projects rootVersions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Model'!

!GTMetacellerMainProject methodsFor: 'initialization' stamp: 'DiegoLont 9/16/2013 13:23'!
addPlatformSymbolsTo: aSet versionSpec: aSpec pragma: aPragma in: aConstructor
	aConstructor evaluatePragma: aPragma.
	aSet addAll: aConstructor attributeMap keys
! !

!GTMetacellerMainProject methodsFor: 'initialization' stamp: 'DiegoLont 9/17/2013 09:30'!
buildProjects
	^self platformSymbols collect: [ :each |
		GTMetacellerAtributedProject on: self configuration main: self platform: (GTPlatformDescription onSymbol: each) ]! !

!GTMetacellerMainProject methodsFor: 'accessing' stamp: 'DiegoLont 4/9/2014 10:17'!
childPlatformsFor: aPlatform
	^(self projectFor: aPlatform) childPlatforms! !

!GTMetacellerMainProject methodsFor: 'initialization' stamp: 'AndreHora 11/2/2013 00:49'!
createPlatformSymbols
	| retVal constructor versionMap symbolicVersionMap executionBlock pragmaDict |
	retVal := Set new.
	constructor := MetacelloVersionConstructor new
		configuration: self configuration new;
		yourself.
	versionMap := Dictionary new.
	symbolicVersionMap := Dictionary new.
	executionBlock := [ :versionSpec :pragma | self addPlatformSymbolsTo: retVal versionSpec: versionSpec pragma: pragma in: constructor ].
	constructor collectAllVersionsFromVersionPragmasInto: versionMap using: executionBlock.
	pragmaDict := constructor extractVersionImportPragmas.
	constructor verifyVersionImportPragmas: pragmaDict definedIn: versionMap.
	constructor
		collectAllVersionsFromVersionImportPragmasInto: versionMap
		using: executionBlock
		satisfiedPragmas: pragmaDict.
	constructor collectAllSymbolicVersionsFromVersionPragmasInto: symbolicVersionMap using: executionBlock.
	^retVal
! !

!GTMetacellerMainProject methodsFor: 'actions' stamp: 'DiegoLont 9/17/2013 13:21'!
createSnapshotVersion: aString baseline: aBaseline
	(self version: aString) ifNotNil: [ 
		" do not create a version that exists already, perhalps an error is more appropriate "
		^self ].
	self configuration compile: (self snapshotVersion: aString baseline: aBaseline)
		classified: 'versions'! !

!GTMetacellerMainProject methodsFor: 'cache' stamp: 'DiegoLont 4/8/2014 14:41'!
ensureProjectsCreated
	self ensureVersionsCreated.
	self projects do: [ :each | each ensureVersionsCreated ]! !

!GTMetacellerMainProject methodsFor: 'testing' stamp: 'DiegoLont 9/17/2013 09:21'!
hasPlatform: aPlatform
	(#common compare: aPlatform caseSensitive: false) = 2 ifTrue: [ ^true ].
	^MetacelloPlatform current defaultPlatformAttributes contains: [ :each |
		(each compare: aPlatform caseSensitive: false) = 2 ]! !

!GTMetacellerMainProject methodsFor: 'accessing' stamp: 'DiegoLont 9/17/2013 13:19'!
itemsFor: aPlatform in: aVersion 
	(self hasPlatform: aPlatform)
		ifTrue: [ ^((self version: aVersion) items
			select: [ :each | (each hasPlatform: aPlatform) and: [ each isGroup not ] ]) ].
	^(self projectFor: aPlatform) itemsFor: aPlatform in: aVersion ! !

!GTMetacellerMainProject methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 13:55'!
normalizePlatforms: aSet
	| retVal |
	retVal := Set new.
	aSet do: [ :newItem | 
		(aSet contains: [ :each | each isParent: newItem])
			ifFalse: [ retVal add: newItem ] ].
	^retVal! !

!GTMetacellerMainProject methodsFor: 'accessing' stamp: 'DiegoLont 3/24/2014 12:58'!
parentProjectFor: aPlatformDescription 
	^self projectFor: (aPlatformDescription parentSymbolIn: self platformSymbols)! !

!GTMetacellerMainProject methodsFor: 'accessing' stamp: 'DiegoLont 3/24/2014 12:38'!
parentVersionFor: aMethod 
	^self rootVersions at: aMethod ifAbsentPut: [ GTMetacellerRootVersion on: aMethod ]! !

!GTMetacellerMainProject methodsFor: 'accessing' stamp: 'DiegoLont 3/24/2014 14:17'!
platformSymbol
	^nil! !

!GTMetacellerMainProject methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 13:24'!
platformSymbols
	^platformSymbols ifNil: [ platformSymbols := self createPlatformSymbols ]! !

!GTMetacellerMainProject methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 13:47'!
platformsFor: aMetacellerItem version: aVersionName
	| platforms |
	platforms := Set new.
	self projects do: [ :each |
		(each hasItem: aMetacellerItem inVersion: aVersionName) ifTrue: [ 
			platforms add: each platformDescription ] ].
	^self normalizePlatforms: platforms! !

!GTMetacellerMainProject methodsFor: 'printing' stamp: 'DiegoLont 3/26/2014 13:39'!
printVersionsFor: aPlatform version: aVersion on: aStream
	| items |
	items := (self itemsFor: aPlatform in: aVersion versionName).
	items ifNotEmpty: [ 
		| first |
		aStream tab; nextPutAll: 'aSpec for: '.
		aPlatform printOn: aStream.
		aStream nextPutAll: ' do: ['; cr.
		first := true.
		items do: [ :each |
			first 
				ifTrue: [ aStream tab; tab; nextPutAll: 'aSpec '.
					first := false ]
				ifFalse: [ aStream nextPut: $;; cr; tab; tab; tab ].
			each printVersionOn: aStream ].
		aStream nextPutAll: '].'; cr ]! !

!GTMetacellerMainProject methodsFor: 'accessing' stamp: 'DiegoLont 3/24/2014 14:23'!
projectFor: aPlatform
	aPlatform ifNil: [ ^nil ].
	^self projects detect: [ :each | each hasPlatform: aPlatform ]! !

!GTMetacellerMainProject methodsFor: 'dummy' stamp: 'DiegoLont 9/16/2013 13:25'!
projects
	^projects ifNil: [ projects := self buildProjects ]! !

!GTMetacellerMainProject methodsFor: 'accessing' stamp: 'DiegoLont 3/24/2014 12:39'!
rootVersions
	^rootVersions ifNil: [ rootVersions := Dictionary new ]! !

!GTMetacellerMainProject methodsFor: 'printing' stamp: 'DiegoLont 9/17/2013 09:20'!
snapshotVersion: aString baseline: aBaseline
	| version |
	" this method needs a baseline "
	version := self version: aBaseline.
	version ifNil: [ ^nil ].
	^String streamContents: [ :s |
		s nextPutAll: (('version', aString) asIdentifier: false); nextPutAll: ': aSpec'; cr;
			tab; nextPutAll: '<version:'''; nextPutAll: aString; nextPutAll: ''' imports: #( ''';nextPutAll: aBaseline; nextPutAll: ''' )>'; cr;
			cr.
		self platformSymbols do: [ :platform |
			self printVersionsFor: platform version: version on: s ] ]! !

!GTMetacellerMainProject methodsFor: 'display' stamp: 'DiegoLont 3/25/2014 11:45'!
title
	^ ((self configuration name beginsWith: 'ConfigurationOf') 
		ifTrue: [self configuration name copyFrom: 'ConfigurationOf' size + 1 to: self configuration name size ] 
		ifFalse: [self configuration name]) asString! !

!GTMetacellerMainProject methodsFor: 'actions' stamp: 'DiegoLont 3/28/2014 12:13'!
updateVersionToCurrent: aVersionName
	self projects do: [ :each |
		each updateVersionToCurrent: aVersionName ]! !

!GTMetacellerProject class methodsFor: 'instance creation' stamp: 'DiegoLont 4/17/2013 16:30'!
on: aConfiguration
	^self basicNew
		initialize: aConfiguration;
		yourself! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 9/13/2013 11:38'!
allMethods
	^GTMetacellerVersion allMethodsForProject: self! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 3/17/2014 14:23'!
bleedingEdge
	bleedingEdge ifNil: [
		[ bleedingEdge := self project bleedingEdge ] on: MetacelloVersionDoesNotExistError do: [] ].
	^bleedingEdge! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 3/17/2014 14:25'!
bleedingEdgeVersion
	^self versions detect: [ :each | each isBleedingEdge ] ifNone: [ nil ]! !

!GTMetacellerProject methodsFor: 'initialization' stamp: 'DiegoLont 3/28/2014 14:02'!
buildReleases
	^GTMetacellerRelease releasesForProject: self! !

!GTMetacellerProject methodsFor: 'initialization' stamp: 'DiegoLont 9/17/2013 09:43'!
buildVersions
	^GTMetacellerVersion versionsForProject: self! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 4/25/2013 15:24'!
checkCurrentVersion
	currentVersion ifNil: [ currentVersion := self project currentVersion ]! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 9/13/2013 10:12'!
childConfigurations
	[ ^(self projectsForVersion: self project stableVersion) collect: [ :each | self configForProject: each ] thenSelect: [ :each | each notNil ] ] on: MetacelloSymbolicVersionDoesNotExistError do: [ ^#() ]! !

!GTMetacellerProject methodsFor: 'actions' stamp: 'DiegoLont 3/26/2014 12:46'!
compileMethod: aMethodDef category: aCategory 
	self configuration compile: aMethodDef classified: aCategory asString! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 9/13/2013 10:09'!
configForProject: aSpec
	| projectReference |
	aSpec ifNil: [  ^nil ].
	(aSpec isKindOf: MetacelloProjectReferenceSpec)
		ifTrue: [ projectReference := aSpec projectReference ]
		ifFalse: [ projectReference := aSpec ].
	projectReference ifNil: [  ^nil ].
	projectReference className ifNil: [  ^nil ].
	^Smalltalk at: (projectReference className asSymbol) ifAbsent: [ nil ]! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 4/17/2013 16:18'!
configuration
	^ configuration! !

!GTMetacellerProject methodsFor: 'actions' stamp: 'DiegoLont 3/30/2014 10:33'!
createRelease: aReleaseName version: aVersionName
	self compileMethod: (String streamContents: [ :s |
		s nextPutAll: aReleaseName asLegalSelector; nextPutAll: ': aSpec'; cr;
			tab; nextPutAll: '<symbolicVersion:'.
		aReleaseName asSymbol asCodeStringOn: s.
		s nextPut: $>; cr;
			tab; nextPutAll: 'aSpec for: #''common'' version: '.
		aVersionName asCodeStringOn: s ]) category: 'releases'! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 4/25/2013 15:22'!
currentVersion
	^ currentVersion! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 3/18/2014 13:53'!
defaultVersion
	self stableVersion ifNotNil: [ ^self stableVersion ].
	self developmentVersion ifNotNil: [ ^self developmentVersion ].
	self bleedingEdgeVersion ifNotNil: [ ^self bleedingEdgeVersion ].
	self addError: 'Could not determine a default version'.
	^nil! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 3/14/2014 15:47'!
developmentVersion
	^self versions detect: [ :each | each isDevelopmentVersion ] ifNone: [ nil ]! !

!GTMetacellerProject methodsFor: 'cache' stamp: 'DiegoLont 3/26/2014 11:56'!
ensureVersionsCreated
	self versions! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 3/18/2014 10:00'!
groups
	self defaultVersion ifNotNil: [ ^self defaultVersion groups ].
	^#()! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 3/18/2014 10:00'!
groupsAndLoosePackages
	self defaultVersion ifNotNil: [ ^self defaultVersion groupsAndLoosePackages ].
	^#()! !

!GTMetacellerProject methodsFor: 'testing' stamp: 'DiegoLont 9/16/2013 11:54'!
hasAttributes
	^false! !

!GTMetacellerProject methodsFor: 'testing' stamp: 'DiegoLont 9/16/2013 13:49'!
hasItem: aMetacellerItem inVersion: aVersion
	^((self version: aVersion) ifNil: [ ^false ]) hasItem: aMetacellerItem! !

!GTMetacellerProject methodsFor: 'initialization' stamp: 'DiegoLont 4/17/2013 16:30'!
initialize: aConfiguration
	self initialize.
	configuration := aConfiguration! !

!GTMetacellerProject methodsFor: 'actions' stamp: 'DiegoLont 3/18/2014 10:58'!
install: aCollection 
	self defaultVersion ifNotNil: [ ^self defaultVersion install: aCollection ].
	" could not determine a version "
	GTMetacellerNoVersion signal: 'Could not dermine a default version for ', self configuration configName! !

!GTMetacellerProject methodsFor: 'testing' stamp: 'DiegoLont 9/13/2013 10:11'!
isProject: aSpec 
	^(aSpec isKindOf: MetacelloProjectReferenceSpec) or: [ (aSpec isKindOf: MetacelloProjectSpec) ]! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 3/31/2014 12:15'!
metacelloVersion: aStringOrSymbol
	self project ifNil: [ ^nil ].
	[ ^self project version: aStringOrSymbol ] on: Exception do: [ :ex | ^ex ]! !

!GTMetacellerProject methodsFor: 'dummy' stamp: 'DiegoLont 9/13/2013 10:24'!
methodClass
	^self configuration! !

!GTMetacellerProject methodsFor: 'dummy' stamp: 'DiegoLont 9/13/2013 10:23'!
methodString
	^''! !

!GTMetacellerProject methodsFor: 'dummy' stamp: 'DiegoLont 9/13/2013 10:24'!
packages
	^#()! !

!GTMetacellerProject methodsFor: 'dummy' stamp: 'DiegoLont 9/13/2013 10:23'!
packagesAndProjects
	^#()! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 3/14/2014 15:40'!
privateDevelopment
	development ifNil: [ 
		[ development := self project development ] on: MetacelloVersionDoesNotExistError do: [ ] ].
	^development! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 3/14/2014 15:39'!
privateStableVersion
	stableVersion ifNil: [ 
		[ stableVersion := self project stableVersion ] on: MetacelloVersionDoesNotExistError do: [ ] ].
	^stableVersion! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 11:33'!
project
	^project ifNil: [ project := configuration project ]! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 9/13/2013 10:11'!
projectsForVersion: aVersion
	aVersion ifNil: [ ^#() ].
	(aVersion isKindOf: Association) ifTrue: [ ^#() ].
	^aVersion spec packages packageSpecsInLoadOrder select: [  :each | self isProject: each ]! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 3/28/2014 14:10'!
release: aString 
	^self releases detect: [ :each | each releaseName = aString ] ifNone: [ nil ]! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 3/28/2014 13:54'!
releases
	^releases ifNil: [ releases := self buildReleases ]! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 3/14/2014 15:37'!
stableVersion
	^self versions detect: [ :each | each isStable ] ifNone: [ nil ]! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 9/14/2013 16:51'!
tags
	^#()! !

!GTMetacellerProject methodsFor: 'actions' stamp: 'DiegoLont 4/2/2014 13:42'!
test: aCollection 
	self defaultVersion ifNotNil: [ self defaultVersion test: aCollection ]! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 9/14/2013 16:51'!
textLabel
	^self displayString! !

!GTMetacellerProject methodsFor: 'actions' stamp: 'DiegoLont 3/28/2014 13:53'!
updateRelease: aReleaseNumber version: aVersionString 
	(self release: aReleaseNumber)
		ifNil: [ self createRelease: aReleaseNumber version: aVersionString ]
		ifNotNilDo: [ :release | release updateWith: aVersionString ]! !

!GTMetacellerProject methodsFor: 'actions' stamp: 'DiegoLont 3/31/2014 09:15'!
updateReleasesFor: aString 
	| versionList releaseNumber |
	versionList := aString subStrings: '.'.
	releaseNumber := nil.
	1 to: (versionList size -1) do: [ :index |
		releaseNumber
			ifNil: [ releaseNumber := ('release', (versionList at: index) asString) ]
			ifNotNil: [ releaseNumber := releaseNumber, '.', (versionList at: index) ].
			self updateRelease: releaseNumber asSymbol version: aString ].
	self updateRelease: 'stable' version: aString
	! !

!GTMetacellerProject methodsFor: 'actions' stamp: 'DiegoLont 3/19/2014 12:01'!
validate
	self defaultVersion ifNotNil: [ self defaultVersion validate ]! !

!GTMetacellerProject methodsFor: 'actions' stamp: 'DiegoLont 4/2/2014 13:40'!
validate: aCollection 
	self defaultVersion ifNotNil: [ ^self defaultVersion validate: aCollection ]! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 4/9/2014 10:42'!
version: aVersion
	^self version: aVersion ifAbsent: [ nil ]! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 4/9/2014 10:42'!
version: aVersion ifAbsent: aBlock
	self project ifNil: [ ^aBlock value ].
	aVersion ifNil: [ ^aBlock value ].
	aVersion isString ifTrue: [ 
		^self versions detect: [ :each | each hasName: aVersion ] ifNone: aBlock ].
	^self version: aVersion versionName ifAbsent: aBlock! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 3/24/2014 13:02'!
versionFor: aMethod
	^self versions detect: [ :each | each method = aMethod ]! !

!GTMetacellerProject methodsFor: 'accessing' stamp: 'DiegoLont 3/24/2014 12:34'!
versions
	^versions ifNil: [ versions := self buildVersions ]! !

!GTMetacellerProject methodsFor: 'roassal' stamp: 'DiegoLont 9/13/2013 11:36'!
viewVersionMapOn: view
	| nodes edges |
	nodes := Dictionary new.
	edges := OrderedCollection new.
	(Pragma allNamed: #version: in: self configuration) do: [:prag | 
		nodes at: (prag argumentAt: 1) put: (project version: (prag argumentAt: 1)) ].
	(Pragma allNamed: #version:imports: in: self configuration) do: [:prag | 
		| version imported |
		version := nodes at: (prag argumentAt: 1) put: (project version: (prag argumentAt: 1)).
		(prag argumentAt: 2) do: [:eachImportPrag |
			imported := nodes at: eachImportPrag ifAbsentPut: [ project version: eachImportPrag ].
			edges add: version -> imported ] ].
	view shape label text: [ :each | each versionNumber printString ].
	view nodes: nodes values.
	view edges: edges from: #key to: #value.
	view horizontalDominanceTreeLayout! !

Object subclass: #GTMetacellerRelease
	instanceVariableNames: 'project version method metacelloVersion isCopy properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Model'!

!GTMetacellerRelease class methodsFor: 'testing' stamp: 'DiegoLont 3/28/2014 14:04'!
isValidRelease: aMethod 
	aMethod pragmas do: [ :each | 
		(each key beginsWith: 'symbolicVersion') ifTrue: [ ^true ] ].
	^false! !

!GTMetacellerRelease class methodsFor: 'instance creation' stamp: 'DiegoLont 3/28/2014 13:59'!
on: aProject method: aMethod
	^self new
		project: aProject;
		method: aMethod;
		yourself! !

!GTMetacellerRelease class methodsFor: 'convenience' stamp: 'DiegoLont 3/28/2014 14:04'!
releasesForProject: aProject
	^(aProject configuration methods
		select: [ :each | self isValidRelease: each ]
		thenCollect: [ :each | self on: aProject method: each ]) 
			asSortedCollection: [ :a :b | a releaseName > b releaseName ]! !

!GTMetacellerRelease methodsFor: 'accessing' stamp: 'DiegoLont 3/30/2014 10:42'!
canModify
	^self isCopy! !

!GTMetacellerRelease methodsFor: 'accessing' stamp: 'DiegoLont 5/12/2014 11:07'!
commonVersion
	^self version commonVersion! !

!GTMetacellerRelease methodsFor: 'initialization' stamp: 'DiegoLont 3/30/2014 10:15'!
determineMetacelloVersion
	self project ifNil: [  ^nil ].
	self releaseName ifNotNil: [ :aSymbol | ^self project metacelloVersion: aSymbol ].
	^nil! !

!GTMetacellerRelease methodsFor: 'initialization' stamp: 'DiegoLont 3/30/2014 10:16'!
determineVersion
	self project ifNil: [  ^nil ].
	self versionName ifNotNil: [ :aString | ^self project version: aString ].
	^nil! !

!GTMetacellerRelease methodsFor: 'accessing version' stamp: 'DiegoLont 4/1/2014 10:44'!
groups
	self version ifNil: [ ^#() ].
	^self version groups! !

!GTMetacellerRelease methodsFor: 'accessing version' stamp: 'DiegoLont 4/1/2014 10:47'!
groupsAndLoosePackages
	self version ifNil: [ ^#() ].
	^self version groupsAndLoosePackages! !

!GTMetacellerRelease methodsFor: 'printing' stamp: 'DiegoLont 4/1/2014 11:12'!
infoText
	| retVal |
	retVal := self labelAsText.
	retVal append: String cr.
	self version
		ifNil: [ 
			(self metacelloVersion isKindOf: Exception)
				ifTrue: [ retVal append: (Text string: self metacelloVersion name attribute: TextColor red) ]
				ifFalse: [ retVal append: (Text string: ('Could not determine version', self versionName asString, '.') attribute: TextColor red) ] ]
		ifNotNil: [ retVal append: self version infoText ].
	^retVal! !

!GTMetacellerRelease methodsFor: 'accessing' stamp: 'DiegoLont 3/30/2014 10:43'!
isCopy
	^isCopy ifNil: [ false ]! !

!GTMetacellerRelease methodsFor: 'testing' stamp: 'DiegoLont 4/9/2014 11:38'!
isMetacellerRelease
	^true! !

!GTMetacellerRelease methodsFor: 'testing' stamp: 'DiegoLont 4/9/2014 11:38'!
isRelease
	^true! !

!GTMetacellerRelease methodsFor: 'printing' stamp: 'DiegoLont 4/9/2014 10:59'!
labelAsText
	| retVal | 
	retVal := Text fromString: ('#', self releaseName).
	self version 
		ifNil: [ retVal append: (Text string: ' (no version)' attribute: TextColor red) ]
		ifNotNil: [ retVal append: (Text string: (' (', self versionName, ')') attribute: TextColor gray) ].
	^retVal! !

!GTMetacellerRelease methodsFor: 'accessing' stamp: 'DiegoLont 3/30/2014 10:15'!
metacelloVersion
	^metacelloVersion ifNil: [ metacelloVersion := self determineMetacelloVersion ]! !

!GTMetacellerRelease methodsFor: 'accessing' stamp: 'DiegoLont 3/28/2014 13:57'!
method
	^ method! !

!GTMetacellerRelease methodsFor: 'accessing' stamp: 'DiegoLont 3/28/2014 13:57'!
method: anObject
	method := anObject! !

!GTMetacellerRelease methodsFor: 'copying' stamp: 'DiegoLont 3/30/2014 10:43'!
postCopy
	super postCopy.
	properties := self properties copy.
	isCopy := true! !

!GTMetacellerRelease methodsFor: 'printing' stamp: 'DiegoLont 3/28/2014 14:11'!
printOn: aStream
	self releaseName printOn: aStream! !

!GTMetacellerRelease methodsFor: 'accessing' stamp: 'DiegoLont 3/28/2014 13:55'!
project
	^ project! !

!GTMetacellerRelease methodsFor: 'accessing' stamp: 'DiegoLont 3/28/2014 13:55'!
project: anObject
	project := anObject! !

!GTMetacellerRelease methodsFor: 'accessing version' stamp: 'DiegoLont 3/30/2014 10:44'!
properties
	^ properties ifNil: [ properties := Dictionary new ]! !

!GTMetacellerRelease methodsFor: 'accessing version' stamp: 'DiegoLont 3/30/2014 10:45'!
propertyAt: aKey ifAbsent: aBlock
	^self properties at: aKey ifAbsent: aBlock! !

!GTMetacellerRelease methodsFor: 'accessing version' stamp: 'DiegoLont 3/30/2014 10:41'!
propertyAt: aKey put: aValue 
	self canModify ifFalse: [ GTMetacellerStateError signal: 'Please create a copy before changing values' ].
	self properties at: aKey put: aValue! !

!GTMetacellerRelease methodsFor: 'accessing' stamp: 'DiegoLont 3/28/2014 14:14'!
releaseName
	self project ifNil: [  ^nil ].
	self method pragmas do: [ :each |
		(each key beginsWith: 'symbolicVersion') ifTrue: [ ^each arguments first ] ].
	^nil! !

!GTMetacellerRelease methodsFor: 'actions' stamp: 'DiegoLont 3/30/2014 10:44'!
saveVersion
	self project createRelease: self releaseName version: self versionName! !

!GTMetacellerRelease methodsFor: 'accessing version' stamp: 'DiegoLont 4/1/2014 10:53'!
test: aCollection 
	self version ifNil: [ ^self ].
	self version test: aCollection! !

!GTMetacellerRelease methodsFor: 'actions' stamp: 'DiegoLont 3/30/2014 10:18'!
updateWith: aString 
	(aString asMetacellerVersion > self versionName asMetacellerVersion)
		ifTrue: [ | newVersion |
			newVersion := self copy.
			newVersion versionName: aString.
			newVersion saveVersion ]! !

!GTMetacellerRelease methodsFor: 'accessing version' stamp: 'DiegoLont 4/1/2014 10:53'!
validate: aCollection 
	self version ifNil: [ ^self ].
	self version validate: aCollection! !

!GTMetacellerRelease methodsFor: 'accessing' stamp: 'DiegoLont 3/30/2014 10:06'!
version
	^version ifNil: [ version := self determineVersion ]! !

!GTMetacellerRelease methodsFor: 'accessing' stamp: 'DiegoLont 3/28/2014 13:55'!
version: anObject
	version := anObject! !

!GTMetacellerRelease methodsFor: 'accessing version' stamp: 'DiegoLont 4/9/2014 14:02'!
versionFor: aString 
	^self version versionFor: aString! !

!GTMetacellerRelease methodsFor: 'accessing version' stamp: 'DiegoLont 3/30/2014 10:45'!
versionName
	^self propertyAt: #versionName ifAbsent: [ self metacelloVersion name ]! !

!GTMetacellerRelease methodsFor: 'accessing version' stamp: 'DiegoLont 3/30/2014 10:40'!
versionName: aString
	self propertyAt: #versionName put: aString! !

Object subclass: #GTMetacellerRootVersion
	instanceVariableNames: 'method commonVersion mainVersion errorVersions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Model'!

!GTMetacellerRootVersion class methodsFor: 'instance creation' stamp: 'DiegoLont 3/24/2014 12:39'!
on: aMethod 
	^self new
		method: aMethod;
		yourself! !

!GTMetacellerRootVersion methodsFor: 'accessing' stamp: 'DiegoLont 3/28/2014 10:19'!
addChild: aVersion
	aVersion platformSymbol ifNil: [ ^self mainVersion: aVersion ].
	aVersion platformSymbol = #'common' ifTrue: [ ^self commonVersion: aVersion ].
	self errorVersions add: aVersion! !

!GTMetacellerRootVersion methodsFor: 'accessing dummy' stamp: 'DiegoLont 3/26/2014 14:43'!
allGroups
	^#()! !

!GTMetacellerRootVersion methodsFor: 'accessing dummy' stamp: 'DiegoLont 3/26/2014 14:44'!
allPackages
	^#()! !

!GTMetacellerRootVersion methodsFor: 'accessing dummy' stamp: 'DiegoLont 3/26/2014 14:43'!
allProjects
	^#()! !

!GTMetacellerRootVersion methodsFor: 'accessing dummy' stamp: 'DiegoLont 3/25/2014 09:50'!
author
	^''! !

!GTMetacellerRootVersion methodsFor: 'accessing dummy' stamp: 'DiegoLont 3/25/2014 09:50'!
blessing
	^''! !

!GTMetacellerRootVersion methodsFor: 'accessing' stamp: 'DiegoLont 3/24/2014 14:30'!
commonVersion
	commonVersion ifNil: [ 
		self mainVersion ifNil: [ ^nil ].
		" build project for all platforms "
		self mainVersion project projects do: [ :each | each versions ] ].
	^commonVersion! !

!GTMetacellerRootVersion methodsFor: 'accessing' stamp: 'DiegoLont 3/24/2014 14:20'!
commonVersion: aVersion
	commonVersion ifNotNil: [ GTMetacellerStateError signal: 'There can only be one common version.' ].
	commonVersion := aVersion! !

!GTMetacellerRootVersion methodsFor: 'accessing dummy' stamp: 'DiegoLont 3/25/2014 09:50'!
description
	^''! !

!GTMetacellerRootVersion methodsFor: 'code generation' stamp: 'DiegoLont 3/26/2014 11:55'!
ensureProjectsCreated
	self mainVersion ensureProjectsCreated! !

!GTMetacellerRootVersion methodsFor: 'accessing' stamp: 'DiegoLont 3/28/2014 10:19'!
errorVersions
	^errorVersions ifNil: [ errorVersions := OrderedCollection new ]! !

!GTMetacellerRootVersion methodsFor: 'testing' stamp: 'DiegoLont 4/9/2014 11:39'!
isMetacellerRelease
	^false! !

!GTMetacellerRootVersion methodsFor: 'accessing dummy' stamp: 'DiegoLont 4/1/2014 15:47'!
item: aString 
	^nil! !

!GTMetacellerRootVersion methodsFor: 'accessing dummy' stamp: 'DiegoLont 4/9/2014 14:01'!
itemsFilteredOn: aString 
	^#()! !

!GTMetacellerRootVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/8/2014 14:40'!
mainVersion
	mainVersion ifNil: [ commonVersion ifNotNil: [ commonVersion ensureProjectsCreated ] ].
	^mainVersion! !

!GTMetacellerRootVersion methodsFor: 'accessing' stamp: 'DiegoLont 3/24/2014 14:20'!
mainVersion: aVersion
	mainVersion ifNotNil: [ GTMetacellerStateError signal: 'There can only be one main version.' ].
	mainVersion := aVersion! !

!GTMetacellerRootVersion methodsFor: 'accessing' stamp: 'DiegoLont 3/24/2014 12:41'!
method
	^ method! !

!GTMetacellerRootVersion methodsFor: 'accessing' stamp: 'DiegoLont 3/24/2014 12:40'!
method: aMethod 
	method := aMethod! !

!GTMetacellerRootVersion methodsFor: 'code generation' stamp: 'DiegoLont 3/31/2014 11:47'!
methodSpecForVersion: aVersion
	| updatedVersion |
	(aVersion = self mainVersion)
		ifTrue: [ updatedVersion := nil]
		ifFalse: [ updatedVersion := aVersion ].
	^String codeStreamContents: [ :s |
		self methodSpecForVersion: updatedVersion on: s ]! !

!GTMetacellerRootVersion methodsFor: 'code generation' stamp: 'DiegoLont 3/31/2014 11:52'!
methodSpecForVersion: aVersion on: aStream
	self ensureProjectsCreated.
	" and the actual streaming "
	self commonVersion streamVersionHeader: aVersion on: aStream.
	self commonVersion streamVersion: aVersion on: aStream! !

!GTMetacellerRootVersion methodsFor: 'code generation' stamp: 'DiegoLont 3/31/2014 10:27'!
methodWithVersionName: aString 
	^String codeStreamContents: [ :s | self streamVersionWithName: aString on: s ]! !

!GTMetacellerRootVersion methodsFor: 'accessing dummy' stamp: 'DiegoLont 3/25/2014 14:38'!
postLoadDoIt
	^''! !

!GTMetacellerRootVersion methodsFor: 'accessing dummy' stamp: 'DiegoLont 3/25/2014 14:38'!
preLoadDoIt
	^''! !

!GTMetacellerRootVersion methodsFor: 'accessing dummy' stamp: 'DiegoLont 4/2/2014 14:24'!
repositories
	^#()! !

!GTMetacellerRootVersion methodsFor: 'accessing' stamp: 'DiegoLont 3/24/2014 14:49'!
repositoriesToWrite
	^#()! !

!GTMetacellerRootVersion methodsFor: 'accessing' stamp: 'DiegoLont 3/28/2014 10:29'!
rootVersion
	^self! !

!GTMetacellerRootVersion methodsFor: 'code generation' stamp: 'DiegoLont 4/2/2014 14:10'!
streamVersionWithName: aString on: aStream
	self ensureProjectsCreated.
	" and the actual streaming "
	self commonVersion streamVersionHeaderWithName: aString on: aStream.
	self commonVersion streamVersion: nil on: aStream! !

!GTMetacellerRootVersion methodsFor: 'accessing dummy' stamp: 'DiegoLont 3/25/2014 15:28'!
timestamp
	^''! !

Object subclass: #GTMetacellerSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Model'!

GTMetacellerSpec subclass: #GTMetacellerItem
	instanceVariableNames: 'version referenceSpec isValidated errors warnings properties isCopy parents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Model'!

GTMetacellerItem subclass: #GTMetacellerGroup
	instanceVariableNames: 'children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Model'!

!GTMetacellerGroup methodsFor: 'accessing' stamp: 'DiegoLont 10/8/2013 10:25'!
buildChildren
	| retVal |
	retVal := OrderedCollection new.
	self addAll: self group name to: retVal version: self version.
	^retVal collect: [ :each | self wrapperFor: each version: self version ]
! !

!GTMetacellerGroup methodsFor: 'accessing' stamp: 'DiegoLont 4/22/2013 13:14'!
children
	^children ifNil: [ children := self buildChildren ]! !

!GTMetacellerGroup methodsFor: 'code generation' stamp: 'DiegoLont 4/3/2014 14:36'!
defaultItemKindString
	^'group'! !

!GTMetacellerGroup methodsFor: 'accessing' stamp: 'DiegoLont 4/22/2013 12:05'!
file
	^self group file! !

!GTMetacellerGroup methodsFor: 'accessing' stamp: 'DiegoLont 4/24/2013 14:49'!
group
	^self referenceSpec! !

!GTMetacellerGroup methodsFor: 'testing' stamp: 'DiegoLont 3/19/2014 11:40'!
hasErrors
	^super hasErrors or: [ self children contains: [ :each | each hasErrors ] ]! !

!GTMetacellerGroup methodsFor: 'testing' stamp: 'DiegoLont 3/19/2014 11:43'!
hasWarnings
	^super hasWarnings or: [ self children contains: [ :each | each hasWarnings ] ]! !

!GTMetacellerGroup methodsFor: 'testing' stamp: 'DiegoLont 5/12/2014 13:54'!
isCompatibleWith: anItem
	^false! !

!GTMetacellerGroup methodsFor: 'testing' stamp: 'DiegoLont 9/12/2013 16:21'!
isGroup
	^true! !

!GTMetacellerGroup methodsFor: 'testing' stamp: 'DiegoLont 4/22/2013 12:06'!
isPackageLoaded
	^self group isPackageLoaded! !

!GTMetacellerGroup methodsFor: 'accessing' stamp: 'DiegoLont 4/22/2013 12:09'!
label
	^self group label! !

!GTMetacellerGroup methodsFor: 'display' stamp: 'DiegoLont 4/24/2013 14:10'!
labelAsText
	^Text string: self label attribute: TextEmphasis italic! !

!GTMetacellerGroup methodsFor: 'code generation' stamp: 'DiegoLont 3/27/2014 14:25'!
specAccessors
	^#( includes )! !

!GTMetacellerGroup methodsFor: 'actions' stamp: 'DiegoLont 5/12/2014 13:43'!
testValid
	self children do: [ :each | each testValid ].
	^self loadList! !

!GTMetacellerGroup methodsFor: 'actions' stamp: 'DiegoLont 5/12/2014 13:43'!
validate
	self children do: [ :each | each validate ].
	^self loadList! !

!GTMetacellerItem class methodsFor: 'instance creation' stamp: 'DiegoLont 4/8/2014 14:26'!
copyFrom: anItem withName: aString 
	^self basicNew
		copyFrom: anItem withName: aString;
		yourself! !

!GTMetacellerItem class methodsFor: 'instance creation' stamp: 'DiegoLont 4/24/2013 14:50'!
on: aVersion spec: aSpec
	^self basicNew
		initialize: aVersion spec: aSpec;
		yourself! !

!GTMetacellerItem methodsFor: 'building' stamp: 'DiegoLont 1/21/2014 14:16'!
addAll: aString to: aCollection version: aVersion
	| spec |
	aVersion ifNil: [ ^self ].
	spec := aVersion packageNamed: aString ifAbsent: [ ^self ].
	(aCollection includes: spec) ifTrue: [ ^self ].
	(self isProject: spec) ifFalse: [ spec requires do: [ :each | self addAll: each to: aCollection version: aVersion ] ].
	(self isGroup: spec) ifFalse: [ aCollection add: spec ].
	(self isProject: spec) ifFalse: [ spec includes do: [ :each | self addAll: each to: aCollection version: aVersion ] ]! !

!GTMetacellerItem methodsFor: 'private' stamp: 'DiegoLont 5/12/2014 13:41'!
addAllTo: aLoadList
	aLoadList add: self children: self children.
	^aLoadList! !

!GTMetacellerItem methodsFor: 'accessing' stamp: 'DiegoLont 3/18/2014 15:48'!
addError: aString
	(self errors includes: aString)
		ifFalse: [ self errors add: aString ]! !

!GTMetacellerItem methodsFor: 'accessing' stamp: 'DiegoLont 5/12/2014 14:38'!
addParent: aParent
	self parents add: aParent! !

!GTMetacellerItem methodsFor: 'accessing' stamp: 'DiegoLont 3/18/2014 15:48'!
addWarning: aString
	(self warnings includes: aString)
		ifFalse: [ self warnings add: aString ]! !

!GTMetacellerItem methodsFor: 'convenience' stamp: 'DiegoLont 4/2/2014 15:43'!
arrayFrom: anOriginal with: aStringOrArray 
	aStringOrArray ifNil: [ ^anOriginal ].
	aStringOrArray isString ifTrue: [ 
		anOriginal
			ifNil: [ ^Array with: aStringOrArray ]
			ifNotNil: [ anOriginal copyWith: aStringOrArray ] ].
	anOriginal
		ifNil: [ ^aStringOrArray ].
	^OrderedCollection new
		addAll: anOriginal;
		addAll: aStringOrArray;
		yourself! !

!GTMetacellerItem methodsFor: 'accessing' stamp: 'DiegoLont 4/24/2013 14:53'!
asString
	^self referenceSpec asString ! !

!GTMetacellerItem methodsFor: 'accessing' stamp: 'DiegoLont 4/2/2014 14:27'!
childVersions
	^self version children collect: [ :each | each item: self itemName ] ! !

!GTMetacellerItem methodsFor: 'accessing' stamp: 'DiegoLont 4/24/2013 15:36'!
children
	^#()! !

!GTMetacellerItem methodsFor: 'accessing' stamp: 'DiegoLont 4/1/2014 15:05'!
commonVersion
	^self version commonVersion item: self itemName! !

!GTMetacellerItem methodsFor: 'initialization' stamp: 'DiegoLont 4/8/2014 14:29'!
copyFrom: anItem withName: aString 
	self initialize.
	isCopy := true.
	referenceSpec := anItem referenceSpec.
	version := anItem version.
	self resetProperties.
	self itemName: aString
! !

!GTMetacellerItem methodsFor: 'code generation' stamp: 'DiegoLont 4/8/2014 14:49'!
createGroupWithName: aString 
	^GTMetacellerGroup copyFrom: self withName: aString! !

!GTMetacellerItem methodsFor: 'code generation' stamp: 'DiegoLont 4/8/2014 14:25'!
createPackageWithName: aString 
	^GTMetacellerPackage copyFrom: self withName: aString! !

!GTMetacellerItem methodsFor: 'code generation' stamp: 'DiegoLont 4/8/2014 14:49'!
createProjectWithName: aString 
	^GTMetacellerProject copyFrom: self withName: aString! !

!GTMetacellerItem methodsFor: 'accessing spec' stamp: 'DiegoLont 4/2/2014 15:19'!
dataFor: aSymbol
	| retVal |
	retVal := self perform: aSymbol.
	retVal isCollection ifTrue: [ 
		retVal ifEmpty: [ ^nil ] ].
	^retVal value! !

!GTMetacellerItem methodsFor: 'code generation' stamp: 'DiegoLont 4/3/2014 14:37'!
defaultItemKindString
	^self subclassResponsibility! !

!GTMetacellerItem methodsFor: 'code generation' stamp: 'DiegoLont 3/26/2014 15:16'!
differenceWith: anItem 
	(self isDifferentFrom: anItem) ifTrue: [ ^GTMetacellerItemDifference on: self parent: anItem ].
	^nil! !

!GTMetacellerItem methodsFor: 'accessing' stamp: 'DiegoLont 3/18/2014 15:46'!
errors
	^errors ifNil: [ errors := OrderedCollection new ]! !

!GTMetacellerItem methodsFor: 'accessing' stamp: 'DiegoLont 5/12/2014 14:53'!
fullTraces
	self parents ifEmpty: [ ^Array with: self itemName ].
	^self parents inject: OrderedCollection new into: [ :traces :parent |
		traces addAll: (parent fullTraces collect: [ :each | each, '/', self itemName ]); yourself ]! !

!GTMetacellerItem methodsFor: 'testing' stamp: 'DiegoLont 3/31/2014 09:57'!
hasBaselineBlessing
	^#( baseline ) includes: self blessing! !

!GTMetacellerItem methodsFor: 'testing' stamp: 'DiegoLont 3/19/2014 11:29'!
hasErrors
	^self errors notEmpty! !

!GTMetacellerItem methodsFor: 'testing' stamp: 'DiegoLont 9/16/2013 13:32'!
hasName: aString 
	^self name = aString! !

!GTMetacellerItem methodsFor: 'testing' stamp: 'DiegoLont 9/16/2013 14:37'!
hasPlatform: aSymbol 
	^self platforms contains: [ :each | each hasSymbol: aSymbol ]! !

!GTMetacellerItem methodsFor: 'testing' stamp: 'DiegoLont 3/31/2014 09:55'!
hasStableBlessing
	^#( stable release ) includes: self blessing! !

!GTMetacellerItem methodsFor: 'testing' stamp: 'DiegoLont 3/19/2014 11:50'!
hasWarnings
	^self warnings notEmpty or: [ self hasErrors ]! !

!GTMetacellerItem methodsFor: 'accessing spec' stamp: 'DiegoLont 3/26/2014 16:15'!
includes
	^self propertyAt: #includes ifAbsent: [ self referenceSpec includes asSet ]! !

!GTMetacellerItem methodsFor: 'accessing' stamp: 'DiegoLont 3/18/2014 15:52'!
infoText
	| retVal |
	retVal := Text fromString: self referenceSpec asString.
	self errors do: [ :each | retVal
		append: String cr;
		append: (Text string: each attribute: TextColor red) ].
	self warnings do: [ :each | retVal
		append: String cr;
		append: (Text string: each attribute: TextColor orange) ].
	^retVal! !

!GTMetacellerItem methodsFor: 'initialization' stamp: 'DiegoLont 3/18/2014 14:26'!
initialize: aVersion
	self initialize.
	version := aVersion! !

!GTMetacellerItem methodsFor: 'initialization' stamp: 'DiegoLont 3/18/2014 14:26'!
initialize: aVersion spec: aSpec
	self initialize.
	version := aVersion.
	referenceSpec := aSpec! !

!GTMetacellerItem methodsFor: 'testing' stamp: 'DiegoLont 5/12/2014 13:57'!
isCompatibleWith: anItem
	(self class = anItem class) ifFalse: [ ^false ].
	^true! !

!GTMetacellerItem methodsFor: 'accessing' stamp: 'DiegoLont 4/2/2014 15:09'!
isCopy
	^isCopy ifNil: [ false ]! !

!GTMetacellerItem methodsFor: 'testing' stamp: 'DiegoLont 3/31/2014 14:34'!
isDifferentFrom: anItem
	self itemName = anItem itemName ifFalse: [ ^true ].
	self specAccessors do: [ :each |
		((self perform: each) value) = ((anItem perform: each) value) ifFalse: [ ^true ] ].
	^false! !

!GTMetacellerItem methodsFor: 'testing' stamp: 'DiegoLont 9/12/2013 16:21'!
isGroup
	^false! !

!GTMetacellerItem methodsFor: 'testing' stamp: 'DiegoLont 4/24/2013 14:38'!
isGroup: aSpec 
	^aSpec isKindOf: MetacelloGroupSpec! !

!GTMetacellerItem methodsFor: 'testing' stamp: 'DiegoLont 4/1/2014 14:09'!
isPackage
	^false! !

!GTMetacellerItem methodsFor: 'testing' stamp: 'DiegoLont 4/24/2013 14:37'!
isPackage: aSpec 
	^aSpec isKindOf: MetacelloPackageSpec! !

!GTMetacellerItem methodsFor: 'testing' stamp: 'DiegoLont 9/12/2013 16:21'!
isProject
	^false! !

!GTMetacellerItem methodsFor: 'testing' stamp: 'DiegoLont 4/24/2013 14:38'!
isProject: aSpec 
	^(aSpec isKindOf: MetacelloProjectReferenceSpec) or: [ aSpec isKindOf: MetacelloProjectSpec ]! !

!GTMetacellerItem methodsFor: 'code generation' stamp: 'DiegoLont 4/3/2014 14:37'!
itemKindString
	^self propertyAt: #itemKind ifAbsent: [ self defaultItemKindString ]! !

!GTMetacellerItem methodsFor: 'accessing spec' stamp: 'DiegoLont 4/3/2014 14:35'!
itemName
	^self propertyAt: #itemName ifAbsent: [ self referenceSpec name ]! !

!GTMetacellerItem methodsFor: 'accessing spec' stamp: 'DiegoLont 4/3/2014 14:35'!
itemName: aString
	self propertyAt: #itemName put: aString! !

!GTMetacellerItem methodsFor: 'accessing' stamp: 'DiegoLont 4/24/2013 15:36'!
labelAsText
	^self referenceSpec label! !

!GTMetacellerItem methodsFor: 'actions' stamp: 'DiegoLont 5/12/2014 14:31'!
loadList
	^GTMetacellerLoadList new
		add: self;
		yourself! !

!GTMetacellerItem methodsFor: 'code generation' stamp: 'DiegoLont 5/12/2014 14:22'!
mergeSpec: anItem
	^(self referenceSpec mergeSpec: anItem referenceSpec)! !

!GTMetacellerItem methodsFor: 'code generation' stamp: 'DiegoLont 5/12/2014 14:40'!
mergeWith: anItem
	| retVal |
	(self class == anItem class) ifFalse: [ GTMetacellerStateError signal: 'Cannot merge two items of different class.' ].
	retVal := self copy.
	retVal referenceSpec: (self mergeSpec: anItem).
	anItem parents do: [ :each | retVal addParent: each ].
	^retVal! !

!GTMetacellerItem methodsFor: 'accessing' stamp: 'DiegoLont 4/24/2013 14:52'!
name
	^self referenceSpec name! !

!GTMetacellerItem methodsFor: 'accessing spec' stamp: 'DiegoLont 5/12/2014 15:42'!
parent
	^(self version parent item: self itemName)! !

!GTMetacellerItem methodsFor: 'accessing' stamp: 'DiegoLont 5/12/2014 14:37'!
parents
	^parents ifNil: [ parents := OrderedCollection new ]! !

!GTMetacellerItem methodsFor: 'accessing' stamp: 'DiegoLont 4/1/2014 15:08'!
platform
	^self version platform! !

!GTMetacellerItem methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 13:46'!
platforms
	^self version platformsFor: self! !

!GTMetacellerItem methodsFor: 'copying' stamp: 'DiegoLont 5/12/2014 14:40'!
postCopy
	super postCopy.
	properties := self properties copy.
	parents := self parents copy.
	isCopy := true! !

!GTMetacellerItem methodsFor: 'printing' stamp: 'DiegoLont 3/24/2014 12:26'!
printOn: aStream
	super printOn: aStream.
	aStream nextPut: $(; nextPutAll: self itemName; nextPut: $)! !

!GTMetacellerItem methodsFor: 'accessing spec' stamp: 'DiegoLont 3/26/2014 15:15'!
properties
	^properties ifNil: [ properties := Dictionary new ]! !

!GTMetacellerItem methodsFor: 'accessing spec' stamp: 'DiegoLont 3/26/2014 15:14'!
propertyAt: aKey ifAbsent: aBlock 
	^self properties at: aKey ifAbsent: aBlock! !

!GTMetacellerItem methodsFor: 'accessing spec' stamp: 'DiegoLont 4/2/2014 15:10'!
propertyAt: aKey put: aValue
	self isCopy ifFalse: [ GTMetacellerStateError signal: 'Only copyies can be modified' ].
	self properties at: aKey put: aValue! !

!GTMetacellerItem methodsFor: 'accessing' stamp: 'DiegoLont 4/24/2013 14:49'!
referenceSpec
	^referenceSpec! !

!GTMetacellerItem methodsFor: 'accessing' stamp: 'DiegoLont 3/26/2014 21:14'!
referenceSpec: aSpec 
	referenceSpec := aSpec! !

!GTMetacellerItem methodsFor: 'actions' stamp: 'DiegoLont 4/8/2014 15:56'!
remove
	self isCopy
		ifTrue: [ self removed: true; saveVersion ]
		ifFalse: [ self copy remove ]! !

!GTMetacellerItem methodsFor: 'accessing spec' stamp: 'DiegoLont 4/8/2014 15:56'!
removed
	^self propertyAt: #removed ifAbsent: [ false ]! !

!GTMetacellerItem methodsFor: 'accessing spec' stamp: 'DiegoLont 4/8/2014 15:56'!
removed: aBoolean
	self propertyAt: #removed put: aBoolean! !

!GTMetacellerItem methodsFor: 'accessing' stamp: 'DiegoLont 3/27/2014 14:25'!
repositories
	self referenceSpec hasRepository ifFalse: [ ^#() ].
	^self referenceSpec repositorySpecs! !

!GTMetacellerItem methodsFor: 'accessing spec' stamp: 'DiegoLont 3/18/2014 14:49'!
repositoriesFrom: aMetacelloMVRepositorySpecs ignoreOverrides: ignoreOverrides

	| repositories repos |
	repositories := MCRepositoryGroup default repositories.
	repos := OrderedCollection new.
	aMetacelloMVRepositorySpecs do: [:aSpec | | description repo |
		description := aSpec description.
		(repo := repositories detect: [:rep | rep description = description ] ifNone: [ aSpec createRepository ]) ~~ nil
			ifTrue: [ repos add: repo ]].
	^repos! !

!GTMetacellerItem methodsFor: 'accessing spec' stamp: 'DiegoLont 3/26/2014 16:15'!
requires
	^self propertyAt: #requires ifAbsent: [ self referenceSpec requires asSet ]! !

!GTMetacellerItem methodsFor: 'accessing spec' stamp: 'DiegoLont 4/2/2014 15:39'!
requires: aString 
	self propertyAt: #requires put: (self arrayFrom: self requires with: aString)! !

!GTMetacellerItem methodsFor: 'accessing spec' stamp: 'DiegoLont 4/3/2014 14:08'!
resetProperties
	self parent
		ifNil: [ 
			self specAccessors do: [ :each | 
				self propertyAt: each put: nil ] ]
		ifNotNilDo: [ :parent |
			self specAccessors do: [ :each | 
				self propertyAt: each put: (parent dataFor: each) ] ].
! !

!GTMetacellerItem methodsFor: 'accessing' stamp: 'DiegoLont 3/18/2014 15:48'!
resetValidated
	warnings := nil.
	errors := nil.
	isValidated := false! !

!GTMetacellerItem methodsFor: 'actions' stamp: 'DiegoLont 4/2/2014 11:31'!
saveVersion
	self version saveWithItem: self! !

!GTMetacellerItem methodsFor: 'actions' stamp: 'DiegoLont 4/3/2014 14:15'!
saveWithSpecString: aString 
	" create a copy "
	| specModifier |
	specModifier := GTSpecModifier on: (self copy resetProperties; yourself).
	" and perform the string "
	(nil class compiler
		source: aString;
		context: specModifier;
		receiver: specModifier;
		requestor: specModifier;
		evaluate).
	specModifier item saveVersion! !

!GTMetacellerItem methodsFor: 'code generation' stamp: 'DiegoLont 3/26/2014 16:14'!
specAccessors
	^#( includes requires )! !

!GTMetacellerItem methodsFor: 'accessing' stamp: 'DiegoLont 3/21/2014 17:08'!
specName
	^self referenceSpec name! !

!GTMetacellerItem methodsFor: 'code generation' stamp: 'DiegoLont 4/8/2014 15:36'!
specString
	^String codeStreamContents: [ :s |
		s startCascade: 'aSpec'.
		(self version generatedItemFor: self itemName)
			ifNil: [ s currentOpenTag assign: self itemKindString value: self itemName ]
			ifNotNilDo: [ :gen | gen streamSpecOn: s specName: 'aSpec' ] ]! !

!GTMetacellerItem methodsFor: 'actions' stamp: 'DiegoLont 5/12/2014 12:03'!
testValid
	" by default we should only need to validate "
	^self validate! !

!GTMetacellerItem methodsFor: 'accessing' stamp: 'DiegoLont 5/12/2014 14:36'!
trace
	^trace ifNil: [ trace := OrderedCollection new ]! !

!GTMetacellerItem methodsFor: 'actions' stamp: 'DiegoLont 5/12/2014 14:30'!
validate
	^self loadList! !

!GTMetacellerItem methodsFor: 'accessing' stamp: 'DiegoLont 4/24/2013 14:30'!
version
	^version! !

!GTMetacellerItem methodsFor: 'accessing' stamp: 'DiegoLont 3/19/2014 11:44'!
warningText
	self hasErrors
		ifTrue: [
			| retVal |
			retVal := Text string: self itemName attribute: TextColor red.
			self errors do: [ :each |
				retVal append: String cr; append: (Text string: each attribute: TextColor red) ].
			^retVal ].
	self hasWarnings ifTrue: [ 
		| retVal |
		retVal := Text string: self itemName attribute: TextColor orange.
			self warnings do: [ :each |
				retVal append: String cr; append: (Text string: each attribute: TextColor orange) ].
		^retVal ].
	^self itemName
	! !

!GTMetacellerItem methodsFor: 'accessing' stamp: 'DiegoLont 3/18/2014 15:48'!
warnings
	^warnings ifNil: [ warnings := OrderedCollection new ]! !

!GTMetacellerItem methodsFor: 'tool' stamp: 'DiegoLont 4/25/2013 09:17'!
wrapperFor: aSpec version: aVersion
	(self isProject: aSpec) ifTrue: [  ^GTMetacellerProjectReference on: aVersion spec: aSpec ].
	(self isGroup: aSpec) ifTrue: [  ^GTMetacellerGroup on: aVersion spec: aSpec ].
	(self isPackage: aSpec) ifTrue: [ ^GTMetacellerPackage on: aVersion spec: aSpec ].
	^aSpec! !

GTMetacellerItem subclass: #GTMetacellerPackage
	instanceVariableNames: 'isNewer isOlder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Model'!

!GTMetacellerPackage methodsFor: 'accessing' stamp: 'DiegoLont 3/31/2014 09:52'!
blessing
	^self version blessing! !

!GTMetacellerPackage methodsFor: 'testing' stamp: 'DiegoLont 3/28/2014 12:02'!
calculateIsNewer
	self file ifNil: [  ^false ].
	(self referenceSpec currentVersionInfo name = self file) ifTrue: [ ^false ].
	self referenceSpec currentVersionInfo allAncestorsDo: [ :each |
		(each name = self file) ifTrue: [ ^false ] ].
	^true! !

!GTMetacellerPackage methodsFor: 'testing' stamp: 'DiegoLont 9/12/2013 16:51'!
calculateIsOlder
	(self file = self referenceSpec name) ifTrue: [  ^false ].	" no version specified "
	(self referenceSpec currentVersionInfo name = self file) ifTrue: [ ^false ].
	self referenceSpec currentVersionInfo allAncestorsDo: [ :each |
		(each name = self file) ifTrue: [ ^true ] ].
	^false! !

!GTMetacellerPackage methodsFor: 'testing' stamp: 'DiegoLont 3/31/2014 09:51'!
checkExistsIn: aRepositorySpecs
	| references gofer |
	gofer := MetacelloGofer new.
	gofer disablePackageCache.
	(self repositoriesFrom: aRepositorySpecs ignoreOverrides: true) 
		do: [:repo | gofer repository: repo ].
	references := self referenceSpec goferPackage resolveAllWith: gofer.
	references ifEmpty: [ ^false ].
	references size > 1 ifTrue: [
		self hasStableBlessing ifTrue: [
			self addWarning: 'Version not unique. Assuming version ', references last name, ' is the correct version.' ] ].
	^true
! !

!GTMetacellerPackage methodsFor: 'code generation' stamp: 'DiegoLont 4/3/2014 14:36'!
defaultItemKindString
	^'package'! !

!GTMetacellerPackage methodsFor: 'accessing spec' stamp: 'DiegoLont 3/26/2014 21:18'!
file
	^self propertyAt: #file ifAbsent: [ self fileReference ]! !

!GTMetacellerPackage methodsFor: 'accessing spec' stamp: 'DiegoLont 3/28/2014 12:17'!
file: aString 
	self propertyAt: #file put: aString! !

!GTMetacellerPackage methodsFor: 'accessing spec' stamp: 'DiegoLont 3/26/2014 21:19'!
fileReference
	| retVal |
	retVal := self referenceSpec file.
	(retVal = self referenceSpec name) ifTrue: [ ^nil ].
	^retVal! !

!GTMetacellerPackage methodsFor: 'testing' stamp: 'DiegoLont 5/12/2014 13:56'!
isCompatibleWith: anItem
	(super isCompatibleWith: anItem) ifFalse: [ ^false ].
	^self name = anItem name! !

!GTMetacellerPackage methodsFor: 'testing' stamp: 'DiegoLont 4/25/2013 09:23'!
isLoaded
	^self packageSpec isPackageLoaded! !

!GTMetacellerPackage methodsFor: 'testing' stamp: 'DiegoLont 9/12/2013 16:51'!
isNewer
	^isNewer ifNil: [ isNewer := self calculateIsNewer ]! !

!GTMetacellerPackage methodsFor: 'testing' stamp: 'DiegoLont 9/12/2013 16:51'!
isOlder
	^isOlder ifNil: [ isOlder := self calculateIsOlder ]! !

!GTMetacellerPackage methodsFor: 'testing' stamp: 'DiegoLont 9/12/2013 16:21'!
isPackage
	^true! !

!GTMetacellerPackage methodsFor: 'testing' stamp: 'DiegoLont 3/18/2014 14:06'!
isValidated
	^isValidated ifNil: [ false ]! !

!GTMetacellerPackage methodsFor: 'accessing' stamp: 'DiegoLont 3/28/2014 11:40'!
label
	^self file ifNil: [ self packageSpec name ]! !

!GTMetacellerPackage methodsFor: 'display' stamp: 'DiegoLont 9/13/2013 13:49'!
labelAsText
	| prefix |
	prefix := ''.
	self needsSaving ifTrue: [ prefix := '* ' ].
	^(Text fromString: prefix), (Text string: self label attributes: self textAttributes)! !

!GTMetacellerPackage methodsFor: 'accessing' stamp: 'DiegoLont 9/17/2013 09:44'!
loadedVersionName
	self referenceSpec workingCopy ifNotNil: [
		^self referenceSpec workingCopy ancestry ancestorString ].
	^self referenceSpec file! !

!GTMetacellerPackage methodsFor: 'private' stamp: 'DiegoLont 5/12/2014 14:57'!
mergeWith: aPackage errors: anErrors warnings: aWarnings 
	(self file = aPackage file) ifTrue: [ ^self ].
	self fullTraces do: [ :myTrace |
		aPackage fullTraces do: [ :each |
			anErrors add: 'Incompatible filenames between ', myTrace, ' and ', each ] ].
	^nil! !

!GTMetacellerPackage methodsFor: 'testing' stamp: 'DiegoLont 4/25/2013 09:15'!
needsSaving
	self packageSpec workingCopy ifNotNilDo: [ :copy | ^copy needsSaving ].
	^false! !

!GTMetacellerPackage methodsFor: 'accessing' stamp: 'DiegoLont 4/25/2013 09:09'!
packageSpec
	^self referenceSpec! !

!GTMetacellerPackage methodsFor: 'accessing spec' stamp: 'DiegoLont 3/26/2014 15:20'!
postLoadDoIt
	^self propertyAt: #postLoadDoIt ifAbsent: [ self referenceSpec postLoadDoIt ]! !

!GTMetacellerPackage methodsFor: 'accessing spec' stamp: 'DiegoLont 3/26/2014 15:20'!
preLoadDoIt
	^self propertyAt: #preLoadDoIt ifAbsent: [ self referenceSpec preLoadDoIt ]! !

!GTMetacellerPackage methodsFor: 'printing' stamp: 'DiegoLont 9/16/2013 14:40'!
printVersionOn: aStream 
	aStream nextPutAll: 'package: '''; nextPutAll: self name; nextPutAll: ''' with: '''; nextPutAll: self loadedVersionName; nextPutAll: ''''! !

!GTMetacellerPackage methodsFor: 'accessing' stamp: 'DiegoLont 3/18/2014 14:09'!
repositorySpecs
	self referenceSpec hasRepository ifTrue: [ ^self referenceSpec repositorySpecs ].
	^self version repositorySpecs! !

!GTMetacellerPackage methodsFor: 'code generation' stamp: 'DiegoLont 3/26/2014 16:14'!
specAccessors
	^#( file includes requires postLoadDoIt preLoadDoIt supplyingAnswers )! !

!GTMetacellerPackage methodsFor: 'accessing spec' stamp: 'DiegoLont 3/26/2014 16:13'!
supplyingAnswers
	^self propertyAt: #supplyingAnswers ifAbsent: [ self referenceSpec answers ]! !

!GTMetacellerPackage methodsFor: 'display' stamp: 'DiegoLont 3/28/2014 12:25'!
textAttributes
	| retVal |
	retVal := OrderedCollection new.
	self isLoaded ifTrue: [ 
		retVal add: TextEmphasis underlined.
		self isNewer ifTrue: [ retVal add: TextEmphasis bold ].
		self isOlder ifTrue: [  retVal add: TextColor gray ] ].
	^retVal! !

!GTMetacellerPackage methodsFor: 'actions' stamp: 'DiegoLont 3/28/2014 12:17'!
updateToCurrent
	self isLoaded
		ifTrue: [ self file: self referenceSpec currentVersionInfo name ]! !

!GTMetacellerPackage methodsFor: 'actions' stamp: 'DiegoLont 5/12/2014 13:42'!
validate
	self isValidated ifTrue: [ ^self ].
	isValidated := true.
	" check if the repository is correct "
	(self checkExistsIn: self repositorySpecs) 
		ifFalse: [ self addError: 'No valid repository for self ', self itemName, '.', String cr, 'Expected this package in one of the following repostories: ', self repositorySpecs asString ].
	self hasStableBlessing ifTrue: [ 
		" explicit filename should be provided"
		self file ifNil: [ self addWarning: 'No explicit filename in a stable version.' ] ].
	self hasBaselineBlessing ifTrue: [ 
		" explicit filename should not be provided"
		self file ifNotNil: [ self addWarning: 'Explicit filename in a baseline version.' ] ].
	" check the dependencies "
	self version validateDependencies: self.
	^self loadList! !

GTMetacellerItem subclass: #GTMetacellerProjectReference
	instanceVariableNames: 'children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Model'!

!GTMetacellerProjectReference methodsFor: 'accessing' stamp: 'DiegoLont 10/7/2013 14:24'!
buildChildren
	" here we return the 'labels' referenced by this project "
	| projectVersion |
	self isLoaded ifFalse: [ ^#() ].
	projectVersion := self projectReference versionOrNil.
	projectVersion ifNil: [  ^#() ].
	(self projectReference loads) ifNil: [ ^projectVersion spec packages packageSpecsInLoadOrder
		collect: [ :each | self wrapperFor: each version: projectVersion ] ].
	" here we need to resolve what loads means ... since metacello does not have an easy way to determin this. "
	^self calculateProjectReferences
	! !

!GTMetacellerProjectReference methodsFor: 'accessing' stamp: 'DiegoLont 10/8/2013 10:27'!
calculateProjectReferences
	" calculate all packages and such from the referred project "
	| projectVersion retVal |
	projectVersion := self projectReference versionOrNil.
	retVal := OrderedCollection new.
	self projectReference loads do: [ :each |
		self addAll: each to: retVal version: projectVersion ].
	^retVal collect: [ :each | self wrapperFor: each version: projectVersion ]! !

!GTMetacellerProjectReference methodsFor: 'accessing' stamp: 'DiegoLont 5/12/2014 15:02'!
children
	" here we return the 'labels' referenced by this project "
	^children ifNil: [ children := self buildChildren ]! !

!GTMetacellerProjectReference methodsFor: 'accessing spec' stamp: 'DiegoLont 4/2/2014 16:06'!
className
	^self propertyAt: #className ifAbsent: [ self projectReference className ]! !

!GTMetacellerProjectReference methodsFor: 'accessing spec' stamp: 'DiegoLont 4/8/2014 15:00'!
className: aString
	^self propertyAt: #className put: aString! !

!GTMetacellerProjectReference methodsFor: 'accessing' stamp: 'DiegoLont 5/12/2014 14:00'!
configForProject
	self configNameForProject
		ifNil: [ ^nil ]
		ifNotNilDo: [ :configName |
			^Smalltalk at: configName ifAbsent: [ nil ] ]! !

!GTMetacellerProjectReference methodsFor: 'accessing' stamp: 'DiegoLont 5/12/2014 13:59'!
configNameForProject
	| projectReference |
	projectReference := self projectReference.
	projectReference ifNil: [  ^nil ].
	projectReference className ifNil: [  ^nil ].
	^projectReference className asSymbol! !

!GTMetacellerProjectReference methodsFor: 'code generation' stamp: 'DiegoLont 4/3/2014 14:36'!
defaultItemKindString
	^'project'! !

!GTMetacellerProjectReference methodsFor: 'accessing spec' stamp: 'DiegoLont 3/26/2014 21:19'!
file
	^self propertyAt: #file ifAbsent: [ self fileReference ]! !

!GTMetacellerProjectReference methodsFor: 'accessing spec' stamp: 'DiegoLont 4/8/2014 14:59'!
file: aString
	^self propertyAt: #file put: aString! !

!GTMetacellerProjectReference methodsFor: 'accessing spec' stamp: 'DiegoLont 3/26/2014 21:19'!
fileReference
	| retVal |
	retVal := self referenceSpec file.
	(retVal = self referenceSpec className) ifTrue: [ ^nil ].
	^retVal! !

!GTMetacellerProjectReference methodsFor: 'testing' stamp: 'DiegoLont 5/12/2014 14:00'!
isCompatibleWith: anItem
	(super isCompatibleWith: anItem) ifFalse: [ ^false ].
	^(self configNameForProject = anItem configNameForProject)! !

!GTMetacellerProjectReference methodsFor: 'testing' stamp: 'DiegoLont 4/24/2013 14:55'!
isLoaded
	^self configForProject notNil! !

!GTMetacellerProjectReference methodsFor: 'testing' stamp: 'DiegoLont 9/12/2013 16:21'!
isProject
	^true! !

!GTMetacellerProjectReference methodsFor: 'accessing' stamp: 'DiegoLont 4/24/2013 14:06'!
label
	^self project label! !

!GTMetacellerProjectReference methodsFor: 'display' stamp: 'DiegoLont 4/24/2013 14:06'!
labelAsText
	| attributes |
	attributes := OrderedCollection new.
	(self isLoaded) ifTrue: [ attributes add: TextEmphasis underlined ].
	attributes add: TextColor blue.
	self versionString 
		ifNil: [ ^(Text string: self  label attributes: attributes), (Text string: ' No version' attribute: TextColor red) ]
		ifNotNil: [ ^(Text string: self label attributes: attributes), (Text string: (' ', self versionString) attribute: TextColor blue) ].
	! !

!GTMetacellerProjectReference methodsFor: 'actions' stamp: 'DiegoLont 5/12/2014 13:21'!
loadConfiguration
	[ :job |
		job title: 'Ensuring configuration of ', self projectReference name,' loaded.'.
		self projectReference ensureProjectLoaded ] asJob run! !

!GTMetacellerProjectReference methodsFor: 'accessing spec' stamp: 'DiegoLont 3/27/2014 14:25'!
loads
	^self propertyAt: #loads ifAbsent: [ ^self projectReference loads ]! !

!GTMetacellerProjectReference methodsFor: 'accessing spec' stamp: 'DiegoLont 4/8/2014 14:59'!
loads: aString
	^self propertyAt: #loads put: aString! !

!GTMetacellerProjectReference methodsFor: 'code generation' stamp: 'DiegoLont 5/12/2014 14:22'!
mergeSpec: anItem
	^self projectReference mergeSpec: anItem projectReference! !

!GTMetacellerProjectReference methodsFor: 'accessing' stamp: 'DiegoLont 5/12/2014 15:01'!
mergeWith: aProjectRef errors: anErrors warnings: aWarnings 
	(self version = aProjectRef version) ifFalse: [
		self fullTraces do: [ :myTrace |
			aProjectRef fullTraces do: [ :each |
				aWarnings add: 'Incompatible versions between ', myTrace, ' and ', each, String cr,
					self version asString, ' ~= ', aProjectRef version asString ] ].
		^nil ].
	(self repositories = aProjectRef repositories) ifFalse: [
		self fullTraces do: [ :myTrace |
			aProjectRef fullTraces do: [ :each |
				aWarnings add: 'Incompatible repositories between ', myTrace, ' and ', each, String cr,
					self repositories asString, ' ~= ', aProjectRef repositories asString ] ].
		^nil ].
	^self mergeWith: aProjectRef! !

!GTMetacellerProjectReference methodsFor: 'accessing spec' stamp: 'DiegoLont 3/26/2014 15:24'!
postLoadDoIt
	^self propertyAt: #preLoadDoIt ifAbsent: [ self referenceSpec preLoadDoIt ]! !

!GTMetacellerProjectReference methodsFor: 'accessing spec' stamp: 'DiegoLont 4/8/2014 14:59'!
postLoadDoIt: aString
	^self propertyAt: #preLoadDoIt put: aString! !

!GTMetacellerProjectReference methodsFor: 'accessing spec' stamp: 'DiegoLont 3/26/2014 15:24'!
preLoadDoIt
	^self propertyAt: #preLoadDoIt ifAbsent: [ self referenceSpec preLoadDoIt ]! !

!GTMetacellerProjectReference methodsFor: 'accessing spec' stamp: 'DiegoLont 4/8/2014 14:59'!
preLoadDoIt: aString
	^self propertyAt: #preLoadDoIt put: aString! !

!GTMetacellerProjectReference methodsFor: 'printing' stamp: 'DiegoLont 9/17/2013 13:09'!
printVersionOn: aStream
	| configClass |
	self referenceSpec projectReference className
		ifNil: [ configClass := nil. ]
		ifNotNil: [ configClass := Smalltalk at: self referenceSpec projectReference className asSymbol ifAbsent: [ nil ] ].
	aStream nextPutAll: 'project: '''; nextPutAll: self name; nextPutAll: ''' with: '.
	configClass
		ifNil: [ aStream nextPutAll: self referenceSpec projectReference versionString printString ]
		ifNotNil: [ aStream nextPut: $';
			nextPutAll: (configClass project version: self referenceSpec projectReference versionString) versionNumber printString;
			nextPut: $' ]! !

!GTMetacellerProjectReference methodsFor: 'accessing spec' stamp: 'DiegoLont 4/24/2013 14:50'!
project
	^self referenceSpec! !

!GTMetacellerProjectReference methodsFor: 'accessing spec' stamp: 'DiegoLont 4/2/2014 15:51'!
projectReference
	self referenceSpec ifNil: [  ^nil ].
	(self referenceSpec isKindOf: MetacelloProjectReferenceSpec)
		ifTrue: [ ^self referenceSpec projectReference ]
		ifFalse: [ ^self referenceSpec ]! !

!GTMetacellerProjectReference methodsFor: 'as yet unclassified' stamp: 'DiegoLont 5/12/2014 15:37'!
resetValidated
	super resetValidated.
	children := nil! !

!GTMetacellerProjectReference methodsFor: 'code generation' stamp: 'DiegoLont 3/27/2014 14:43'!
specAccessors
	^#( versionString className file postLoadDoIt preLoadDoIt loads )! !

!GTMetacellerProjectReference methodsFor: 'accessing spec' stamp: 'DiegoLont 3/26/2014 16:26'!
supplyingAnswers
	^self propertyAt: #supplyingAnswers ifAbsent: [ self referenceSpec answers ]! !

!GTMetacellerProjectReference methodsFor: 'accessing spec' stamp: 'DiegoLont 4/8/2014 14:59'!
supplyingAnswers: aString
	^self propertyAt: #supplyingAnswers put: aString! !

!GTMetacellerProjectReference methodsFor: 'actions' stamp: 'DiegoLont 5/12/2014 11:10'!
testValid
	self loadConfiguration.
	^super testValid! !

!GTMetacellerProjectReference methodsFor: 'actions' stamp: 'DiegoLont 5/12/2014 15:02'!
validate
	| loadList |
	loadList := super validate.
	self errors addAll: loadList errors.
	self warnings addAll: loadList warnings.
	^loadList! !

!GTMetacellerProjectReference methodsFor: 'accessing spec' stamp: 'DiegoLont 4/2/2014 15:51'!
versionString
	^self propertyAt: #versionString ifAbsent: [ self referenceSpec versionString ]! !

!GTMetacellerProjectReference methodsFor: 'accessing spec' stamp: 'DiegoLont 4/8/2014 14:58'!
versionString: aString
	^self propertyAt: #versionString put: aString! !

!GTMetacellerProjectReference methodsFor: 'tool' stamp: 'DiegoLont 5/12/2014 14:43'!
wrapperFor: aSpec version: aVersion
	| retVal |
	retVal := super wrapperFor: aSpec version: aVersion.
	retVal parents add: self.
	^retVal! !

GTMetacellerSpec subclass: #GTMetacellerItemDifference
	instanceVariableNames: 'item parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Model'!

!GTMetacellerItemDifference class methodsFor: 'instance creation' stamp: 'DiegoLont 4/2/2014 15:33'!
on: anItem parent: aParent
	^self new
		item: anItem;
		addParent: aParent;
		yourself! !

!GTMetacellerItemDifference methodsFor: 'accessing' stamp: 'DiegoLont 3/26/2014 21:09'!
addParent: aParent
	self parent ifNil: [ self parent: aParent ].
	self parent: (self parent mergeWith: aParent)! !

!GTMetacellerItemDifference methodsFor: 'accessing' stamp: 'DiegoLont 4/8/2014 15:00'!
dataFor: aString 
	| retVal |
	retVal := self item dataFor: aString.
	(retVal isString not and: [ retVal isCollection ])
		ifTrue: [
			| parentData |
			parentData := (self parent dataFor: aString).
			parentData ifNil: [ ^retVal ].
			retVal := retVal reject: [ :each | parentData includes: each ].
			retVal ifEmpty: [ ^nil ] ]
		ifFalse: [
			(self parent dataFor: aString) = retVal
				ifTrue: [ ^nil ] ].
	^retVal! !

!GTMetacellerItemDifference methodsFor: 'code generation' stamp: 'DiegoLont 3/26/2014 21:15'!
differenceWith: anItem 
	(self item isDifferentFrom: anItem) ifFalse: [ ^nil ].
	self addParent: anItem.
	(self item isDifferentFrom: self parent) ifFalse: [ ^nil ].
	^self! !

!GTMetacellerItemDifference methodsFor: 'accessing' stamp: 'DiegoLont 3/26/2014 14:58'!
item
	^ item! !

!GTMetacellerItemDifference methodsFor: 'accessing' stamp: 'DiegoLont 3/26/2014 14:58'!
item: anObject
	item := anObject! !

!GTMetacellerItemDifference methodsFor: 'accessing' stamp: 'DiegoLont 3/27/2014 14:33'!
itemKindString
	^self item itemKindString! !

!GTMetacellerItemDifference methodsFor: 'accessing' stamp: 'DiegoLont 3/26/2014 15:24'!
itemName
	^self item itemName! !

!GTMetacellerItemDifference methodsFor: 'accessing' stamp: 'DiegoLont 3/26/2014 21:09'!
parent
	^ parent! !

!GTMetacellerItemDifference methodsFor: 'accessing' stamp: 'DiegoLont 3/26/2014 21:09'!
parent: anItem
	parent := anItem! !

!GTMetacellerItemDifference methodsFor: 'accessing version' stamp: 'DiegoLont 4/2/2014 15:02'!
platform
	^self item platform! !

!GTMetacellerItemDifference methodsFor: 'accessing' stamp: 'DiegoLont 3/27/2014 14:39'!
repositories
	| retVal parentRepos |
	retVal := self item repositories.
	parentRepos := (self parent repositories).
	retVal := retVal reject: [ :each |
		parentRepos includes: each ].
	^retVal! !

!GTMetacellerItemDifference methodsFor: 'accessing' stamp: 'DiegoLont 3/27/2014 14:30'!
specAccessors
	^self item specAccessors! !

!GTMetacellerSpec methodsFor: 'code generation' stamp: 'DiegoLont 3/27/2014 14:16'!
differenceWith: anItem 
	^self subclassResponsibility! !

!GTMetacellerSpec methodsFor: 'code generation' stamp: 'DiegoLont 3/27/2014 14:16'!
itemKindString
	^self subclassResponsibility! !

!GTMetacellerSpec methodsFor: 'accessing' stamp: 'DiegoLont 4/8/2014 15:57'!
removed
	^false! !

!GTMetacellerSpec methodsFor: 'code generation' stamp: 'DiegoLont 4/1/2014 15:37'!
specAccessors
	^self subclassResponsibility! !

!GTMetacellerSpec methodsFor: 'code generation' stamp: 'DiegoLont 4/8/2014 15:57'!
streamSpecOn: aStream specName: aSpecName
	| needsWith needsWithBlock repositories |
	self removed ifTrue: [ ^self ].
	repositories := self repositories.
	needsWithBlock := repositories notEmpty.
	self specAccessors allButFirstDo: [ :each | needsWithBlock := needsWithBlock or: [ 
			(self dataFor: each) notNil ] ].
	needsWith := needsWithBlock not and: [ (self dataFor: self specAccessors first) notNil ].
	aStream currentOpenTag assign: self itemKindString value: self itemName.
	needsWith ifTrue: [
		aStream currentOpenTag withValue: (self dataFor: self specAccessors first) ].
	needsWithBlock ifTrue: [
		aStream currentOpenTag withBlock: [
			| cascade |
			cascade := aStream startCascade: aSpecName.
			self specAccessors do: [ :each |
				(self dataFor: each) ifNotNilDo: [ :data |
					cascade assign: each value: data ] ].
			repositories do: [ :repo |
				cascade assign: 'repository' value: repo ] ] ]! !

Object subclass: #GTMetacellerVersion
	instanceVariableNames: 'parent children version configuration cachedPackageMap project groups items wrappers isNew properties isCopy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Model'!

!GTMetacellerVersion class methodsFor: 'conveniance' stamp: 'DiegoLont 9/13/2013 11:39'!
allMethodsForProject:aProject
	^aProject configuration methods collect: [ :each |
		self on: aProject configuration method: each project: aProject ]! !

!GTMetacellerVersion class methodsFor: 'testing' stamp: 'DiegoLont 4/16/2013 11:27'!
isValidVersion: aVersion
	aVersion pragmas do: [ :each |
		(each key beginsWith: 'version') ifTrue: [  ^true ] ].
	^false! !

!GTMetacellerVersion class methodsFor: 'actions' stamp: 'DiegoLont 4/17/2013 11:07'!
load: aString 
	self version ifNotNil: [ self version load: aString ]! !

!GTMetacellerVersion class methodsFor: 'instance creation' stamp: 'DiegoLont 4/17/2013 16:03'!
on: aConfiguration method: aMethod project: aProject
	^self basicNew
		initialize: aConfiguration method: aMethod project: aProject;
		yourself! !

!GTMetacellerVersion class methodsFor: 'conveniance' stamp: 'DiegoLont 3/26/2014 10:48'!
versionsForProject: aProject
	^(aProject configuration methods
		select: [ :each | self isValidVersion: each ]
		thenCollect: [ :each | self on: aProject configuration method: each project: aProject ]) 
			asSortedCollection: [ :a :b | a versionName > b versionName ]! !

!GTMetacellerVersion methodsFor: 'actions' stamp: 'DiegoLont 4/25/2013 15:38'!
actions
	| retVal |
	retVal := OrderedCollection new.
	retVal add: ((GLMGenericAction new) 
			action: [ :list  | list selection inspect ];
			title: 'Inspect'
			yourself).
	retVal add: ((GLMGenericAction new) 
			action: [ :list  | list selection method browse ];
			title: 'Browse method'
			yourself).
	retVal add: ((GLMGenericAction new) 
			action: [ :list  | list selection load ];
			title: 'Load'
			yourself).
 	retVal add: ((GLMGenericAction new) 
			action: [ :list  | list selection fetch ];
			title: 'Fetch'
			yourself).
"
	This checks the current version, but it needs to update the ui without recreating the versions
 	retVal add: ((GLMGenericAction new) 
			action: [ :list  | list selection checkCurrentVersion ];
			title: 'Check current version'
			yourself).
"	self isDevelopment ifTrue: [ 
	 	retVal add: ((GLMGenericAction new) 
			action: [ :list  | list selection update ];
			title: 'Update'
			yourself) ].
	^retVal! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 3/28/2014 10:01'!
addChild: aVersion
"	(self platformSymbol = #'common' and: [ #( pharo squeak ) includes: aVersion platformSymbol ]) 
		ifTrue: [ self halt ].
"	self children add: aVersion! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/2/2014 15:27'!
allGroups
	^self items select: [ :each | each isGroup ]! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/2/2014 15:27'!
allPackages
	^self items select: [ :each | each isPackage ]! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/2/2014 15:27'!
allProjects
	^self items select: [ :each | each isProject ]! !

!GTMetacellerVersion methodsFor: 'accessing version' stamp: 'DiegoLont 3/25/2014 12:30'!
author
	^self propertyAt: #author ifAbsent: [ self version author ]! !

!GTMetacellerVersion methodsFor: 'accessing version' stamp: 'DiegoLont 3/26/2014 10:45'!
author: aString 
	self propertyAt: #author put: aString! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 9/12/2013 16:18'!
belongsToGroup: aSpec
	^(self tagsOf: aSpec) notEmpty! !

!GTMetacellerVersion methodsFor: 'accessing version' stamp: 'DiegoLont 3/25/2014 12:31'!
blessing
	^self propertyAt: #blessing ifAbsent: [ self version spec blessing value ]! !

!GTMetacellerVersion methodsFor: 'accessing version' stamp: 'DiegoLont 3/26/2014 10:44'!
blessing: aSymbol 
	self propertyAt: #blessing put: aSymbol! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 3/31/2014 12:21'!
buildGroups
	self hasError ifTrue: [ ^#() ].
	self version ifNotNil: [ 
		^self version groups collect: [ :each | GTMetacellerGroup on: self spec: each ] ].
	^#()! !

!GTMetacellerVersion methodsFor: 'initialization' stamp: 'DiegoLont 4/2/2014 15:28'!
buildItems
	^self packagesAndProjects sort: [ :a :b | a itemName < b itemName ]! !

!GTMetacellerVersion methodsFor: 'testing' stamp: 'DiegoLont 3/30/2014 10:07'!
canModify
	^self project hasAttributes and: [ self isCopy ]! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 3/21/2014 16:39'!
category
	^self method category! !

!GTMetacellerVersion methodsFor: 'actions' stamp: 'DiegoLont 4/25/2013 15:28'!
checkCurrentVersion
	self project checkCurrentVersion! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/2/2014 14:28'!
childVersions
	^self children! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 3/24/2014 14:05'!
children
	^children ifNil: [ children := OrderedCollection new ]! !

!GTMetacellerVersion methodsFor: 'accessing generation' stamp: 'DiegoLont 3/28/2014 11:17'!
commentInfoSelectors
	^#( blessing author timestamp )! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 3/26/2014 11:45'!
commonVersion
	^self parent commonVersion! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:17'!
configuration
	^ configuration! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:17'!
configuration: anObject
	configuration := anObject! !

!GTMetacellerVersion methodsFor: 'code generation' stamp: 'DiegoLont 4/2/2014 16:21'!
createNewVersionWith: aClass selector: aString 
	| newVersion |
	newVersion := self copy.
	newVersion methodName: aString.
	" set the default values "
	self blessing = #'baseline'
		ifTrue: [ newVersion blessing: #'baseline' ]
		ifFalse: [ newVersion blessing: #'development' ].
	newVersion author: Author fullName.
	newVersion timestamp: DateAndTime now asDate yyyymmdd.
	newVersion repositories: OrderedCollection new.
	aClass new perform: aString with: newVersion.
	" eveluate the pragma "
	(aClass methodDict at: aString) pragmas do: [ :pragma |
		(pragma key beginsWith: #'version:') ifTrue: [ newVersion versionName: (pragma argumentAt: 1)  ].
		(pragma key = #'version:imports:') ifTrue: [ newVersion importedVersions: (pragma argumentAt: 2) ] ].
	newVersion saveVersion! !

!GTMetacellerVersion methodsFor: 'private' stamp: 'DiegoLont 3/19/2014 11:54'!
createWrapperFor: aSpec
	(self isProject: aSpec) ifTrue: [  ^GTMetacellerProjectReference on: self spec: aSpec ].
	(self isGroup: aSpec) ifTrue: [  ^GTMetacellerGroup on: self spec: aSpec ].
	(self isPackage: aSpec) ifTrue: [ ^GTMetacellerPackage on: self spec: aSpec ].
	^aSpec
	! !

!GTMetacellerVersion methodsFor: 'accessing version' stamp: 'DiegoLont 3/25/2014 12:27'!
description
	^self propertyAt: #description ifAbsent: [ 	self version description ]! !

!GTMetacellerVersion methodsFor: 'accessing version' stamp: 'DiegoLont 3/26/2014 10:44'!
description: aString 
	self propertyAt: #description put: aString! !

!GTMetacellerVersion methodsFor: 'magritte-description' stamp: 'DiegoLont 3/25/2014 12:13'!
descriptionAuthor
	<magritteDescription>
	^MAStringDescription new
		accessor: #author;
		label: 'Author';
		priority: 400;
		yourself! !

!GTMetacellerVersion methodsFor: 'magritte-description' stamp: 'DiegoLont 3/25/2014 12:09'!
descriptionBlessing
	<magritteDescription>
	^MASingleOptionDescription new
		accessor: #blessing;
		label: 'Blessing';
		priority: 300;
		options: self possibleBlessings;
		yourself! !

!GTMetacellerVersion methodsFor: 'magritte-description' stamp: 'DiegoLont 3/25/2014 12:09'!
descriptionDescription
	<magritteDescription>
	^MAMemoDescription new
		accessor: #description;
		label: 'Description';
		priority: 200;
		yourself! !

!GTMetacellerVersion methodsFor: 'magritte-description' stamp: 'DiegoLont 3/25/2014 12:25'!
descriptionName
	<magritteDescription>
	^MAStringDescription new
		accessor: #versionName;
		label: 'Name';
		priority: 100;
		readonly: self isExisting;
		yourself! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 13:15'!
determineVersion
	self project ifNil: [  ^nil ].
	self method pragmas do: [ :each |
		(each key beginsWith: 'version') ifTrue: [ ^self project metacelloVersion: (each arguments first) ] ].
	^nil! !

!GTMetacellerVersion methodsFor: 'printing' stamp: 'DiegoLont 9/13/2013 10:23'!
displayString
	^self textLabel! !

!GTMetacellerVersion methodsFor: 'cache' stamp: 'DiegoLont 3/26/2014 11:54'!
ensureProjectsCreated
	self project ensureProjectsCreated! !

!GTMetacellerVersion methodsFor: 'accessing error' stamp: 'DiegoLont 3/31/2014 12:20'!
errorMessage
	^self version asString! !

!GTMetacellerVersion methodsFor: 'actions' stamp: 'DiegoLont 4/16/2013 16:38'!
fetch
	self version ifNotNil: [ self version fetch ]! !

!GTMetacellerVersion methodsFor: 'accessing generation' stamp: 'DiegoLont 3/26/2014 14:45'!
findItem: anItem in: aCollection 
	^aCollection detect: [ :each |
		each itemName = anItem itemName ] ifNone: [ nil ]! !

!GTMetacellerVersion methodsFor: 'accessing generation' stamp: 'DiegoLont 4/8/2014 15:41'!
generatedItemFor: aString
	| retVal |
	retVal := self item: aString.
	self version importedVersions do: [ :importName |
		| importedVersion |
		importedVersion := self project version: importName.
		retVal := self updateItem: retVal with: (importedVersion item: aString) ].
	self updateItem: retVal with: (self parent item: aString).
	^retVal! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/22/2013 14:06'!
groups
	^groups ifNil: [ groups := self buildGroups ]! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 9/12/2013 18:37'!
groupsAndLoosePackages
	^(OrderedCollection withAll: self packagesWithoutGroups)
		addAll: self groups;
		yourself! !

!GTMetacellerVersion methodsFor: 'testing' stamp: 'DiegoLont 3/21/2014 16:26'!
hasAuthor
	^self version author notNil! !

!GTMetacellerVersion methodsFor: 'testing' stamp: 'DiegoLont 3/21/2014 16:25'!
hasBlessing
	^self version blessing notNil! !

!GTMetacellerVersion methodsFor: 'testing' stamp: 'DiegoLont 3/21/2014 16:26'!
hasDescription
	^self version description notNil! !

!GTMetacellerVersion methodsFor: 'testing' stamp: 'DiegoLont 3/31/2014 12:19'!
hasError
	^self version isKindOf: Error! !

!GTMetacellerVersion methodsFor: 'testing' stamp: 'DiegoLont 4/1/2014 15:06'!
hasItem: aMetacellerItem
	^self items contains: [ :each | each itemName = aMetacellerItem name ]! !

!GTMetacellerVersion methodsFor: 'testing' stamp: 'DiegoLont 3/26/2014 13:36'!
hasName: aString 
	^self versionName = aString! !

!GTMetacellerVersion methodsFor: 'accessing version' stamp: 'DiegoLont 3/25/2014 12:31'!
importedVersions
	^self propertyAt: #importedVersions ifAbsent: [ self version importedVersions ]! !

!GTMetacellerVersion methodsFor: 'accessing version' stamp: 'DiegoLont 3/26/2014 10:44'!
importedVersions: aCollection 
	self propertyAt: #importedVersions put: aCollection! !

!GTMetacellerVersion methodsFor: 'accessing generation' stamp: 'DiegoLont 3/25/2014 14:37'!
infoFor: aSymbol
	| data parentData |
	data := self perform: aSymbol.
	parentData := self parent perform: aSymbol.
	data = parentData ifTrue: [ ^nil ].
	^data
! !

!GTMetacellerVersion methodsFor: 'printing' stamp: 'DiegoLont 3/28/2014 11:31'!
infoText
	| retVal |
	retVal := self asText.
	retVal
		append: String cr;
		append: self description.
	#( blessing author timestamp versionStatus importedVersions ) do: [ :symbol |
		retVal append: String cr; append: symbol capitalized; append: ': '; append: (self perform: symbol) asMetacellerLabel ].

	self rootVersion errorVersions do: [ :each |
		retVal append: String cr;
		append: (Text string: ('Unrecognized platform: ', each platformSymbol) attribute: TextColor red) ].

	self packagesAndProjects do: [ :each |
		each hasWarnings ifTrue: [ 
			retVal append: String cr; append: each warningText ] ].
	^retVal
		! !

!GTMetacellerVersion methodsFor: 'initialization' stamp: 'DiegoLont 3/24/2014 14:25'!
initialize: aConfiguration method: aMethod project: aProject
	self initialize.
	parent := aProject parentVersionFor: aMethod.
	configuration := aConfiguration.
	project := aProject.
	parent addChild: self.
! !

!GTMetacellerVersion methodsFor: 'actions' stamp: 'DiegoLont 3/18/2014 12:22'!
install: aCollection
	aCollection ifNil: [ ^self load ].
	self load: (aCollection collect: [ :each | each itemName ])! !

!GTMetacellerVersion methodsFor: 'testing' stamp: 'DiegoLont 3/17/2014 11:42'!
isBaseline
	^self blessing = #baseline! !

!GTMetacellerVersion methodsFor: 'testing' stamp: 'DiegoLont 3/18/2014 09:38'!
isBleedingEdge
	self project ifNil: [  ^false ].
	self version ifNil: [ ^false ].
	^self version = self project bleedingEdge! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 3/30/2014 10:08'!
isCopy
	^isCopy ifNil: [ false ]! !

!GTMetacellerVersion methodsFor: 'testing' stamp: 'DiegoLont 4/24/2013 11:44'!
isCurrent
	self project ifNil: [  ^false ].
	self version ifNil: [ ^false ].
	^self project currentVersion = self version! !

!GTMetacellerVersion methodsFor: 'testing' stamp: 'DiegoLont 4/26/2013 15:50'!
isDevelopment
	^self blessing = #development! !

!GTMetacellerVersion methodsFor: 'testing' stamp: 'DiegoLont 3/14/2014 15:40'!
isDevelopmentVersion
	self project ifNil: [  ^false ].
	self version ifNil: [ ^false ].
	^self project privateDevelopment = self version! !

!GTMetacellerVersion methodsFor: 'testing' stamp: 'DiegoLont 3/25/2014 12:25'!
isExisting
	^self isNew not! !

!GTMetacellerVersion methodsFor: 'testing' stamp: 'DiegoLont 4/17/2013 13:14'!
isGroup: aSpec 
	^aSpec isKindOf: MetacelloGroupSpec! !

!GTMetacellerVersion methodsFor: 'testing' stamp: 'DiegoLont 3/17/2014 14:28'!
isLatestVersion
	^self project latest = self version! !

!GTMetacellerVersion methodsFor: 'testing' stamp: 'DiegoLont 4/9/2014 11:38'!
isMetacellerRelease
	^false! !

!GTMetacellerVersion methodsFor: 'testing' stamp: 'DiegoLont 3/25/2014 12:25'!
isNew
	^isNew ifNil: [ false ]! !

!GTMetacellerVersion methodsFor: 'testing' stamp: 'DiegoLont 3/25/2014 12:25'!
isNew: aBoolean
	isNew := aBoolean! !

!GTMetacellerVersion methodsFor: 'testing' stamp: 'DiegoLont 4/24/2013 13:57'!
isPackage: aSpec 
	^aSpec isKindOf: MetacelloPackageSpec! !

!GTMetacellerVersion methodsFor: 'testing' stamp: 'DiegoLont 4/24/2013 13:57'!
isProject: aSpec 
	^(aSpec isKindOf: MetacelloProjectReferenceSpec) or: [ aSpec isKindOf: MetacelloProjectSpec ]! !

!GTMetacellerVersion methodsFor: 'testing' stamp: 'DiegoLont 3/17/2014 11:41'!
isRelease
	^self blessing = #release! !

!GTMetacellerVersion methodsFor: 'testing' stamp: 'DiegoLont 3/14/2014 15:41'!
isStable
	self project ifNil: [  ^false ].
	self version ifNil: [ ^false ].
	^(self project privateStableVersion = self version)! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/2/2014 15:26'!
item: aName 
	^self items detect: [ :each | each itemName = aName ] ifNone: [ nil ]! !

!GTMetacellerVersion methodsFor: 'actions' stamp: 'DiegoLont 4/2/2014 15:27'!
itemListFrom: anItemOrList
	anItemOrList
		ifNil: [ ^self items ].
	anItemOrList isCollection ifFalse: [ ^Array with: anItemOrList ].
	anItemOrList ifEmpty: [ ^self items ].
	^anItemOrList! !

!GTMetacellerVersion methodsFor: 'accessing generation' stamp: 'DiegoLont 4/1/2014 09:46'!
itemSelectors
	^#( allProjects allPackages allGroups )! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 9/17/2013 09:38'!
items
	^items ifNil: [ items := self buildItems ]! !

!GTMetacellerVersion methodsFor: 'accessing generation' stamp: 'DiegoLont 4/9/2014 14:00'!
itemsFilteredOn: aSymbol
	^self items select: [ :each | each perform: aSymbol ]! !

!GTMetacellerVersion methodsFor: 'accessing generation' stamp: 'DiegoLont 3/26/2014 14:53'!
itemsForSymbol: aSymbol
	| retVal |
	retVal := self perform: aSymbol.
	self version importedVersions do: [ :importName |
		| importedVersion |
		importedVersion := self project version: importName.
		self updateItems: retVal with: (importedVersion perform: aSymbol) ].
	self updateItems: retVal with: (self parent perform: aSymbol).
	^retVal! !

!GTMetacellerVersion methodsFor: 'accessing generation' stamp: 'DiegoLont 4/9/2014 13:59'!
itemsFrom: aCollection filterOn: aSymbol
	| retVal |
	retVal := aCollection select: [:each | each perform: aSymbol ].
	self version importedVersions do: [ :importName |
		| importedVersion |
		importedVersion := self project version: importName.
		self updateItems: retVal with: (importedVersion itemsFilteredOn: aSymbol) ].
	self updateItems: retVal with: (self parent itemsFilteredOn: aSymbol).
	^retVal! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 3/17/2014 14:33'!
labelAsText
	^self textLabel! !

!GTMetacellerVersion methodsFor: 'actions' stamp: 'DiegoLont 4/16/2013 16:26'!
load
	self version ifNotNil: [ self version load ]! !

!GTMetacellerVersion methodsFor: 'actions' stamp: 'DiegoLont 4/25/2013 11:09'!
load: aString 
	self version ifNotNil: [ self version load: aString ]! !

!GTMetacellerVersion methodsFor: 'accessing generation' stamp: 'DiegoLont 3/25/2014 14:49'!
mainInfoSelectors
	^#( blessing description preLoadDoIt postLoadDoIt author timestamp )! !

!GTMetacellerVersion methodsFor: 'accessing generation' stamp: 'DiegoLont 3/28/2014 11:17'!
mainInfoSelectorsForDisplay: aBoolean
	aBoolean ifFalse: [ ^self mainInfoSelectors ].
	^self mainInfoSelectors reject: [ :each | self commentInfoSelectors includes: each ].! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 3/24/2014 12:32'!
method
	^self parent method! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:43'!
methodCategory
	^self method category! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:42'!
methodClass
	^self configuration! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 3/26/2014 12:00'!
methodName
	^self propertyAt: #methodName ifAbsent: [ self method selector ]! !

!GTMetacellerVersion methodsFor: 'accessing version' stamp: 'DiegoLont 3/26/2014 12:02'!
methodName: aString 
	self propertyAt: #methodName put: aString! !

!GTMetacellerVersion methodsFor: 'code generation' stamp: 'DiegoLont 3/26/2014 10:33'!
methodSpec
	^self parent methodSpecForVersion: self! !

!GTMetacellerVersion methodsFor: 'code generation' stamp: 'DiegoLont 4/8/2014 14:37'!
methodSpecForVersion: aVersion 
	^self parent methodSpecForVersion: aVersion! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:42'!
methodString
	^self method asString! !

!GTMetacellerVersion methodsFor: 'code generation' stamp: 'DiegoLont 3/24/2014 14:08'!
methodWithVersionName: aString 
	^self parent methodWithVersionName: aString! !

!GTMetacellerVersion methodsFor: 'accessing generation' stamp: 'DiegoLont 3/25/2014 09:55'!
needsGenerating
	self needsGeneratingMainInfo ifTrue: [ ^true ].
	self needsGeneratingItems ifTrue: [ ^true ].
	^false! !

!GTMetacellerVersion methodsFor: 'accessing generation' stamp: 'DiegoLont 4/2/2014 11:49'!
needsGeneratingItems
	self itemSelectors do: [ :each |
		(self itemsForSymbol: each) ifNotEmpty: [ ^true ] ].
	^false! !

!GTMetacellerVersion methodsFor: 'accessing generation' stamp: 'DiegoLont 4/2/2014 11:49'!
needsGeneratingMainInfo
	self mainInfoSelectors do: [ :each |
		(self infoFor: each) ifNotNil: [ ^true ] ].
	self repositoriesToWrite ifNotEmpty: [ ^true ].
	^false! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/24/2013 14:40'!
packageNamed: aString ifAbsent: aBlock 
	self version ifNil: [ ^nil ].
	^self version packageNamed: aString ifAbsent: aBlock! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:48'!
packages
	self version ifNil: [ ^#() ].
	^self version packages! !

!GTMetacellerVersion methodsFor: 'private' stamp: 'DiegoLont 10/8/2013 11:00'!
packagesAndGroups
	cachedPackageMap ifNil: [
		cachedPackageMap := Dictionary new.
		self version ifNotNil: [
			self groups do: [:eachGroup |
				eachGroup children do: [ :eachPackage |
					(cachedPackageMap at: eachPackage referenceSpec ifAbsentPut: [OrderedCollection new])
						add: eachGroup name ] ] ] ].
	^ cachedPackageMap! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/24/2013 13:56'!
packagesAndProjects
	self version ifNil: [ ^#() ].
	^(self version spec packages packageSpecsInLoadOrder)
		collect: [ :each | self wrapperFor: each ]! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:47'!
packagesForSpecNamed: aVersionString 
	self version ifNotNil: [ ^self version packagesForSpecNamed: aVersionString ].
	^#()! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 9/12/2013 16:22'!
packagesWithoutGroups
	" make sure the groups are built first "
	self groups.
	^self packagesAndProjects select: [ :each | (each isPackage or: [ each isProject ]) and: [ (self belongsToGroup: each) not ] ]! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 3/24/2014 12:40'!
parent
	^ parent! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 3/26/2014 11:45'!
platform
	^self project platformSymbol asString! !

!GTMetacellerVersion methodsFor: 'accessing generation' stamp: 'DiegoLont 3/24/2014 14:16'!
platformSymbol
	^self project platformSymbol! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 3/26/2014 13:39'!
platformsFor: aMetacellerItem
	^self project platformsFor: aMetacellerItem version: self versionName! !

!GTMetacellerVersion methodsFor: 'accessing magritte' stamp: 'DiegoLont 3/25/2014 12:16'!
possibleBlessings
	^#( #baseline #bleedingEdge #development #stable #release )! !

!GTMetacellerVersion methodsFor: 'copying' stamp: 'DiegoLont 4/2/2014 16:23'!
postCopy
	" remove aliases of references we might change: "
	super postCopy.
	properties := properties copy.
	items := items copy.
	groups := groups copy.
	isCopy := true! !

!GTMetacellerVersion methodsFor: 'accessing version' stamp: 'DiegoLont 3/25/2014 14:38'!
postLoadDoIt
	^self propertyAt: #postLoadDoIt ifAbsent: [ self version basicSpec postLoadDoIt ]! !

!GTMetacellerVersion methodsFor: 'accessing version' stamp: 'DiegoLont 3/26/2014 10:44'!
postLoadDoIt: aString
	^self propertyAt: #postLoadDoIt put: aString! !

!GTMetacellerVersion methodsFor: 'accessing version' stamp: 'DiegoLont 3/25/2014 14:37'!
preLoadDoIt
	^self propertyAt: #preLoadDoIt ifAbsent: [ self version basicSpec preLoadDoIt ]! !

!GTMetacellerVersion methodsFor: 'accessing version' stamp: 'DiegoLont 3/25/2014 15:26'!
preLoadDoIt: aString
	^self propertyAt: #preLoadDoIt put: aString! !

!GTMetacellerVersion methodsFor: 'printing' stamp: 'DiegoLont 3/14/2014 15:36'!
printOn: aStream
	aStream nextPutAll: self displayString! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/17/2013 16:07'!
project
	^project! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:48'!
projects
	self version ifNil: [ ^#() ].
	^self version projects! !

!GTMetacellerVersion methodsFor: 'accessing generation' stamp: 'DiegoLont 3/26/2014 14:46'!
projectsForVersion: aString 
	self shouldBeImplemented.! !

!GTMetacellerVersion methodsFor: 'actions' stamp: 'DiegoLont 3/30/2014 10:07'!
promoteToRelease
	| newVersion |
	newVersion := self commonVersion copy.
	newVersion blessing: #release.
	newVersion saveVersion.
	self updateReleases! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 3/25/2014 12:32'!
properties
	^properties ifNil: [ properties := Dictionary new ]! !

!GTMetacellerVersion methodsFor: 'accessing version' stamp: 'DiegoLont 3/25/2014 12:28'!
propertyAt: aSymbol ifAbsent: aBlock
	^self properties at: aSymbol ifAbsent: aBlock! !

!GTMetacellerVersion methodsFor: 'accessing version' stamp: 'DiegoLont 3/30/2014 10:09'!
propertyAt: aSymbol put: aValue
	self canModify ifFalse: [ 
		self isCopy
			ifTrue: [ GTMetacellerStateError signal: 'Cannot change ', aSymbol asString, ' of the main version.' ]
			ifFalse: [ GTMetacellerStateError signal: 'Only copy of version should be modified.' ] ].
	self properties at: aSymbol put: aValue! !

!GTMetacellerVersion methodsFor: 'accessing version' stamp: 'DiegoLont 4/2/2014 15:27'!
replaceOrAddItem: anItem
	self canModify ifFalse: [ GTMetacellerStateError signal: 'Can only change a copy of a version.' ].
	self items removeAllSuchThat: [ :each | each itemName = anItem itemName ].
	self items add: anItem! !

!GTMetacellerVersion methodsFor: 'accessing version' stamp: 'DiegoLont 4/8/2014 15:25'!
repositories
	^self propertyAt: #repostories
		ifAbsent: [ (self repositorySpecs repositoryDescriptions) asSet ]! !

!GTMetacellerVersion methodsFor: 'accessing version' stamp: 'DiegoLont 4/2/2014 16:23'!
repositories: aCollection
	self propertyAt: #repostories put: aCollection! !

!GTMetacellerVersion methodsFor: 'accessing generation' stamp: 'DiegoLont 4/2/2014 15:23'!
repositoriesToWrite
	| retVal |
	retVal := self repositories
		removeAllFoundIn: self parent repositories;
		yourself.
	self importedVersions do: [ :each |
		retVal removeAllFoundIn: (self project version: each) repositories ].
	^retVal
! !

!GTMetacellerVersion methodsFor: 'accessing version' stamp: 'DiegoLont 4/2/2014 16:23'!
repository: aString 
	(self propertyAt: #repositories ifAbsent: [ GTMetacellerStateError signal: 'Repositories were not initialized properly in this copy' ]) add: aString! !

!GTMetacellerVersion methodsFor: 'accessing version' stamp: 'DiegoLont 3/18/2014 14:34'!
repositorySpecs
	^self version loader spec repositories! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 3/28/2014 10:29'!
rootVersion
	^self parent rootVersion! !

!GTMetacellerVersion methodsFor: 'actions' stamp: 'DiegoLont 3/26/2014 10:42'!
saveAs: aVersionName
	" check if this version does not exist yet "
	(self project version: aVersionName) ifNotNil: [ GTMetacellerDuplicateVersion signal: 'Version with name ', aVersionName, ' already exists.' ].
	self project compileMethod: (self methodWithVersionName: aVersionName) category: self category! !

!GTMetacellerVersion methodsFor: 'actions' stamp: 'DiegoLont 3/28/2014 12:20'!
saveVersion
	self project compileMethod: self methodSpec category: self category! !

!GTMetacellerVersion methodsFor: 'actions' stamp: 'DiegoLont 4/2/2014 11:53'!
saveWithItem: anItem
	| newVersion |
	newVersion := self copy.
	newVersion replaceOrAddItem: anItem.
	newVersion saveVersion! !

!GTMetacellerVersion methodsFor: 'actions' stamp: 'DiegoLont 3/25/2014 16:02'!
saveWithSpecString: aString
	| tempClass selector |
	tempClass := self project createTempClass.
	tempClass compile: aString classified: self category.
	tempClass methodDict size = 1 ifFalse: [ GTMetacellerCompilationError signal: 'No valid spec.' ].
	(self method selector = (tempClass methodDict keys anyOne))
		ifTrue: [ self updateVersionWith: tempClass selector: self selector ]
		ifFalse: [ self createNewVersionWith: tempClass selector: (tempClass methodDict keys anyOne) ]! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:38'!
selector
	^self method selector! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 3/28/2014 12:32'!
sortedChildren
	^self children sort: [ :v1 :v2 | v1 platformSymbol > v2 platformSymbol ]! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:34'!
spec
	self version ifNotNil: [ ^self version spec ].
	^nil! !

!GTMetacellerVersion methodsFor: 'code generation' stamp: 'DiegoLont 3/31/2014 12:18'!
specString
	self hasError ifTrue: [ ^self errorMessage ].
	^String codeStreamContents: [ :s |
		(self streamVersionHeaderWithName: self versionName on: s)
			with: [
				self needsGeneratingMainInfo ifTrue: [
					self streamMainInfoOn: s forDisplay: true ] ] ]! !

!GTMetacellerVersion methodsFor: 'code generation' stamp: 'DiegoLont 4/9/2014 13:56'!
specStringFor: aCollection 
	self hasError ifTrue: [ ^self errorMessage ].
	^String codeStreamContents: [ :s |
		(self streamVersionHeaderWithName: self versionName on: s)
			with: [
				self needsGeneratingMainInfo ifTrue: [
					self streamMainInfoOn: s forDisplay: true ] ].
		self streamItems: aCollection on: s ]! !

!GTMetacellerVersion methodsFor: 'code generation' stamp: 'DiegoLont 3/31/2014 13:58'!
streamItemSpecsOn: aStream
	self itemSelectors do: [ :each |
		| data |
		data := self itemsForSymbol: each.
		data ifNotEmpty: [ 
			| cascade |
			cascade := aStream startCascade: 'aSpec'.
			data do: [ :item |
				item streamSpecOn: aStream specName: 'aSpec' ].
			cascade close ] ]! !

!GTMetacellerVersion methodsFor: 'code generation' stamp: 'DiegoLont 4/9/2014 13:57'!
streamItems: aCollection on: aStream
	#( isProject isPackage isGroup ) do: [ :each |
		| data |
		data := self itemsFrom: aCollection filterOn: each.
		data ifNotEmpty: [ 
			| cascade |
			cascade := aStream startCascade: 'aSpec'.
			data do: [ :item |
				item streamSpecOn: aStream specName: 'aSpec' ].
			cascade close ] ]! !

!GTMetacellerVersion methodsFor: 'code generation' stamp: 'DiegoLont 3/31/2014 13:58'!
streamMainInfoOn: aStream forDisplay: aBoolean
	self needsGeneratingMainInfo ifTrue: [
		| cascade |
		cascade := aStream startCascade: 'aSpec'.
		(self mainInfoSelectorsForDisplay: aBoolean) do: [ :each |
			(self infoFor: each) ifNotNilDo: [ :data |
				cascade assign: each value: data ] ].
		self streamRepositoriesOn: cascade.
		aBoolean ifTrue: [
			| comment |
			comment := aStream startComment: 'Following lines will be automatically set by Metaceller if not overridden:'.
			self commentInfoSelectors do: [ :each |
				(self infoFor: each) ifNotNilDo: [ :data |
					comment assign: each value: data ] ] ].
		cascade close ]! !

!GTMetacellerVersion methodsFor: 'code generation' stamp: 'DiegoLont 4/2/2014 13:56'!
streamRepositoriesOn: aCascade
	self repositoriesToWrite do: [ :each |
		aCascade assign: 'repository' value: each ]! !

!GTMetacellerVersion methodsFor: 'code generation' stamp: 'DiegoLont 4/2/2014 11:38'!
streamVersion: aVersion on: aStream 
	(aVersion notNil and: [ aVersion platformSymbol = self platformSymbol])
		ifTrue: [ aVersion streamVersionOn: aStream ]
		ifFalse: [ self streamVersionOn: aStream ].
	self sortedChildren do: [ :each |
		each streamVersion: aVersion on: aStream ]! !

!GTMetacellerVersion methodsFor: 'code generation' stamp: 'DiegoLont 3/28/2014 12:22'!
streamVersionHeader: aVersion on: aStream
	(aVersion notNil and: [ aVersion platformSymbol = self platformSymbol]) ifTrue: [ ^aVersion streamVersionHeaderOn: aStream ].
	^self streamVersionHeaderOn: aStream! !

!GTMetacellerVersion methodsFor: 'code generation' stamp: 'DiegoLont 3/31/2014 11:48'!
streamVersionHeaderOn: aStream
	^aStream method: self methodName versionName: self versionName importedVersions: self version importedVersions! !

!GTMetacellerVersion methodsFor: 'code generation' stamp: 'DiegoLont 3/31/2014 11:17'!
streamVersionHeaderWithName: aString on: aStream
	^aStream version: aString importedVersions: self version importedVersions! !

!GTMetacellerVersion methodsFor: 'code generation' stamp: 'DiegoLont 4/2/2014 11:38'!
streamVersionOn: aStream
	self needsGenerating ifTrue: [
		(aStream openPlatform: self platformSymbol)
			with: [
				self streamMainInfoOn: aStream forDisplay: false.
				self streamItemSpecsOn: aStream ] ]! !

!GTMetacellerVersion methodsFor: 'printing' stamp: 'DiegoLont 4/24/2013 11:43'!
tags
	self version ifNil: [  ^#() ].
	^Array with: self blessing! !

!GTMetacellerVersion methodsFor: 'printing' stamp: 'DiegoLont 9/12/2013 16:10'!
tagsOf: aSpec
	(aSpec isKindOf: GTMetacellerItem) ifTrue: [ ^self tagsOf: aSpec referenceSpec ].
	(aSpec isKindOf: MetacelloProjectReferenceSpec) ifTrue: [  ^self tagsOf: aSpec projectReference ].
	^self packagesAndGroups at: aSpec ifAbsent: [OrderedCollection new]! !

!GTMetacellerVersion methodsFor: 'actions' stamp: 'DiegoLont 5/12/2014 15:43'!
test: anItemOrList
	(self itemListFrom: anItemOrList) do: [ :item |
		item resetValidated.
		item testValid ] displayingProgress: ('Testing version ', self version asString)! !

!GTMetacellerVersion methodsFor: 'actions' stamp: 'DiegoLont 3/18/2014 14:20'!
testItem: anItem
	anItem resetValidated.
	anItem testValid! !

!GTMetacellerVersion methodsFor: 'actions' stamp: 'DiegoLont 3/18/2014 14:18'!
testItems: aCollection 
	aCollection do: [ :each | self testItem: each ]! !

!GTMetacellerVersion methodsFor: 'printing' stamp: 'DiegoLont 3/25/2014 11:39'!
textLabel
	| attributes |
	attributes := OrderedCollection new.
	self version ifNil: [ attributes add: TextColor red ].
	self isBleedingEdge ifTrue: [ attributes add: TextColor red  ].
	self isDevelopmentVersion ifTrue: [ attributes add: TextColor blue ].
	self isCurrent ifTrue: [ attributes add: TextEmphasis underlined ].
	self isStable ifTrue: [ attributes add: TextEmphasis bold ].
	^Text string: self versionName attributes: attributes! !

!GTMetacellerVersion methodsFor: 'accessing version' stamp: 'DiegoLont 3/25/2014 15:28'!
timestamp
	^self propertyAt: #timestamp ifAbsent: [ self version timestamp ]! !

!GTMetacellerVersion methodsFor: 'accessing version' stamp: 'DiegoLont 3/25/2014 16:06'!
timestamp: aString 
	self propertyAt: #timestamp put: aString! !

!GTMetacellerVersion methodsFor: 'printing' stamp: 'DiegoLont 3/25/2014 11:42'!
title
	^self project title, ' ', self versionName! !

!GTMetacellerVersion methodsFor: 'actions' stamp: 'DiegoLont 4/17/2013 15:39'!
update
	self isDevelopment ifTrue: [
		MetacelloToolBox updateToLatestPackageVersionsIn: self configuration description: 'Please describe this version.' ]! !

!GTMetacellerVersion methodsFor: 'accessing generation' stamp: 'DiegoLont 4/8/2014 15:39'!
updateItem: anItem with: aBaselineItem
	anItem ifNil: [ ^nil ].
	aBaselineItem ifNil: [ ^anItem ].
	^anItem differenceWith: aBaselineItem! !

!GTMetacellerVersion methodsFor: 'accessing generation' stamp: 'DiegoLont 3/26/2014 14:45'!
updateItems: anItemsCollection with: aBaselineItems
	aBaselineItems do: [ :each |
		| myItem |
		myItem := self findItem: each in: anItemsCollection.
		myItem ifNotNil: [ anItemsCollection remove: myItem.
			myItem := myItem differenceWith: each.
			myItem ifNotNil: [ anItemsCollection add: myItem ] ] ]! !

!GTMetacellerVersion methodsFor: 'actions' stamp: 'DiegoLont 3/28/2014 13:45'!
updateReleases
	self project updateReleasesFor: self versionName! !

!GTMetacellerVersion methodsFor: 'actions' stamp: 'DiegoLont 3/28/2014 12:14'!
updateToCurrent
	" walk our version to update "
	self allPackages do: [ :each | each updateToCurrent ]! !

!GTMetacellerVersion methodsFor: 'actions' stamp: 'DiegoLont 3/28/2014 12:12'!
updateToCurrentAndSave
	self project updateVersionToCurrent: self versionName.
	self saveVersion! !

!GTMetacellerVersion methodsFor: 'code generation' stamp: 'DiegoLont 3/31/2014 11:46'!
updateVersionWith: aClass selector: aString 
	| updatedVersion |
	updatedVersion := self copy.
	aClass new perform: aString with: updatedVersion.
	" eveluate the pragma "
	(aClass methodDict at: aString) pragmas do: [ :pragma |
		(pragma key = #'version:imports:') ifTrue: [ updatedVersion importedVersions: (pragma argumentAt: 2) ] ].
	updatedVersion saveVersion! !

!GTMetacellerVersion methodsFor: 'actions' stamp: 'DiegoLont 3/19/2014 12:02'!
validate
	self validate: nil! !

!GTMetacellerVersion methodsFor: 'actions' stamp: 'DiegoLont 4/2/2014 13:45'!
validate: anItemOrList 
	(self itemListFrom: anItemOrList) do: [ :each |
		each resetValidated; validate ]! !

!GTMetacellerVersion methodsFor: 'testing' stamp: 'DiegoLont 3/18/2014 15:49'!
validateDependencies: aGTMetacellerPackage 
	" for now we leave this empty "! !

!GTMetacellerVersion methodsFor: 'actions' stamp: 'DiegoLont 3/18/2014 14:20'!
validateItem: anItem
	anItem resetValidated.
	anItem validate! !

!GTMetacellerVersion methodsFor: 'actions' stamp: 'DiegoLont 3/18/2014 13:38'!
validateItems: aCollection 
	aCollection do: [ :each |
		self validateItem: each ]! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:18'!
version
	^ version ifNil: [ version := self determineVersion ]! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 4/16/2013 11:17'!
version: anObject
	version := anObject! !

!GTMetacellerVersion methodsFor: 'accessing project' stamp: 'DiegoLont 4/9/2014 14:03'!
versionFor: aString 
	^(self project projectFor: aString) version: self versionName! !

!GTMetacellerVersion methodsFor: 'accessing version' stamp: 'DiegoLont 3/25/2014 15:25'!
versionName
	^self propertyAt: #versionName ifAbsent: [ self version name ]! !

!GTMetacellerVersion methodsFor: 'accessing version' stamp: 'DiegoLont 3/25/2014 15:26'!
versionName: aString
	^self propertyAt: #versionName put: aString! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 3/17/2014 11:38'!
versionNumber
	^self asString! !

!GTMetacellerVersion methodsFor: 'accessing version' stamp: 'DiegoLont 3/28/2014 11:28'!
versionStatus
	[ ^self version versionStatus ] on: Exception do: [ :ex | ^ex description ]! !

!GTMetacellerVersion methodsFor: 'accessing version' stamp: 'DiegoLont 9/13/2013 10:25'!
versions
	^#()! !

!GTMetacellerVersion methodsFor: 'private' stamp: 'DiegoLont 3/19/2014 11:54'!
wrapperFor: aSpec
	^self wrappers at: aSpec ifAbsentPut: [ self createWrapperFor: aSpec ]! !

!GTMetacellerVersion methodsFor: 'accessing' stamp: 'DiegoLont 3/19/2014 11:54'!
wrappers
	^wrappers ifNil: [ wrappers := Dictionary new ]! !

Object subclass: #GTPlatformDescription
	instanceVariableNames: 'symbol parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Model'!

GTPlatformDescription class
	instanceVariableNames: 'cached'!

GTPlatformDescription class
	instanceVariableNames: 'cached'!

!GTPlatformDescription class methodsFor: 'instance creation' stamp: 'DiegoLont 9/16/2013 12:54'!
allSymbols
	^self cached keys! !

!GTPlatformDescription class methodsFor: 'instance creation' stamp: 'DiegoLont 3/28/2014 10:24'!
buildOnSymbol: aSymbol
	| symbol |
	symbol := aSymbol asSymbol.
	symbol = #'common' ifTrue: [ ^self on: nil symbol: symbol ].
	(#( #'gemstone' #'squeakCommon' ) includes: symbol) ifTrue: [ ^self on: (self onSymbol: #common) symbol: symbol ].
	(#( #'pharo' #'squeak' ) includes: symbol) ifTrue: [ ^self on: (self onSymbol: #squeakCommon) symbol: symbol ].
	(#( #'pharo1.x' #'pharo2.x' #'pharo3.x' ) includes: symbol) ifTrue: [ ^self on: (self onSymbol: #pharo) symbol: symbol ].
	(#( #'pharo1.0.x' #'pharo1.1.x' #'pharo1.2.x' #'pharo1.3.x' #'pharo1.4.x' ) includes: symbol) ifTrue: [ ^self on: (self onSymbol: #'pharo1.x') symbol: symbol ].
	(#( #'gs2.x' #'gs3.x' ) includes: symbol) ifTrue: [ ^self on: (self onSymbol: #'gemstone') symbol: symbol ].
	(#( #'gs2.3.x' #'gs2.4.x' ) includes: symbol) ifTrue: [ ^self on: (self onSymbol: #'gs2.x') symbol: symbol ].
	(#( #'gs3.0.x' #'gs3.1.x' ) includes: symbol) ifTrue: [ ^self on: (self onSymbol: #'gs3.x') symbol: symbol ].
	" if this is reached, we need to specify more symbols in the hierarchie "
	^self on: nil symbol: aSymbol! !

!GTPlatformDescription class methodsFor: 'instance creation' stamp: 'DiegoLont 9/16/2013 12:52'!
cached
	^cached ifNil: [ cached := Dictionary new ]! !

!GTPlatformDescription class methodsFor: 'instance creation' stamp: 'DiegoLont 9/16/2013 11:35'!
on: aParent symbol: aSymbol
	^self basicNew
		initialize: aParent symbol: aSymbol;
		yourself! !

!GTPlatformDescription class methodsFor: 'instance creation' stamp: 'DiegoLont 3/28/2014 10:25'!
onSymbol: aSymbol
	| symbol |
	symbol := aSymbol asSymbol.
	^self cached at: symbol ifAbsentPut: [ self buildOnSymbol: symbol ]! !

!GTPlatformDescription class methodsFor: 'instance creation' stamp: 'DiegoLont 9/16/2013 12:52'!
resetCache
	cached := nil! !

!GTPlatformDescription methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 11:37'!
attributes
	^self attributesWith: OrderedCollection new! !

!GTPlatformDescription methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 11:37'!
attributesWith: aCollection
	self parent ifNotNil: [ self parent attributesWith: aCollection ].
	^aCollection
		add: self symbol;
		yourself! !

!GTPlatformDescription methodsFor: 'testing' stamp: 'DiegoLont 3/28/2014 10:20'!
hasSymbol: aSymbol
	" this is case sensitive!! "
	^symbol = aSymbol! !

!GTPlatformDescription methodsFor: 'initialization' stamp: 'DiegoLont 3/28/2014 11:20'!
initialize: aParent symbol: aSymbol
	self initialize.
	parent := aParent.
	symbol := aSymbol! !

!GTPlatformDescription methodsFor: 'testing' stamp: 'DiegoLont 9/16/2013 14:07'!
isParent: aPlatformDescription 
	aPlatformDescription ifNil: [ ^false ].
	aPlatformDescription parent = self ifTrue: [ ^true ].
	^self isParent: aPlatformDescription parent! !

!GTPlatformDescription methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 11:35'!
parent
	^ parent! !

!GTPlatformDescription methodsFor: 'private' stamp: 'DiegoLont 3/24/2014 12:59'!
parentOrSelfIn: aCollection 
	(aCollection includes: self symbol) ifTrue: [ ^self symbol ].
	self parent ifNil: [ ^nil ].
	^self parent parentOrSelfIn: aCollection! !

!GTPlatformDescription methodsFor: 'accessing' stamp: 'DiegoLont 3/24/2014 12:59'!
parentSymbolIn: aCollection 
	self parent ifNil: [ ^nil ].
	^self parent parentOrSelfIn: aCollection! !

!GTPlatformDescription methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 13:58'!
printOn: aStream
	self symbol printOn: aStream! !

!GTPlatformDescription methodsFor: 'accessing' stamp: 'DiegoLont 9/16/2013 11:35'!
symbol
	^ symbol! !

Error subclass: #GTMetacellerError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Model'!

GTMetacellerError subclass: #GTMetacellerCompilationError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Model'!

GTMetacellerError subclass: #GTMetacellerDuplicateVersion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Model'!

GTMetacellerError subclass: #GTMetacellerNoVersion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Model'!

GTMetacellerError subclass: #GTMetacellerStateError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Model'!
GTMetacelloPlatform initialize!
